
   proc Make_Configuration_File {} {
# This is normally sourced from /MIDAS/exogam/tcl/vxicontrol.patch.tcl
}

   proc OLD_Make_Configuration_File {file} {

#    obtain list of all data sources

   set-footer "Obtaining list of all known data sources from the VXI servers"
   set CurrentVXIServer VXI
   set nameslist [ersinquire *.Addr]
   set-footer "Creating configuration information in file $file"

   set z [catch {open $file w} f]
   if {$z != 0} then {midas-warning "Unable to create file $file\n$f"; return}

   puts $f "[format "%-25s%-10s%-10s%-10s%-10s%-10s" name group item label enable databits]"

   foreach name $nameslist {
      if {[second [split $name .]] == "GIR"} then continue

#     for this data source obtain address information 
      set address [read-vxi-register $name]
      set group [expr $address & 255]
      set item [expr $address >> 8]
      set label [expr $address]

#    remove the trailing .Addr to obtain name of data source 
      set name [string range $name 0 [expr [string length $name] - 6]]

      switch -glob [first [split $name .]] {
          Saphir*   {set module Saphir}
          ADC6414V* {set module ADC6414V}
          HRGe8x0*  {set module HRGe8x0}
          default   {set-footer "module type not supported"; continue}
      }

#    obtain if enabled or not
      switch $module {
          Saphir    {set enable [read-vxi-register [first [split $name .]].Enable]}
          ADC6414V  {set enable [read-vxi-register $name.Enable]}
          HRGe8x0   {set enable [read-vxi-register [first [split $name .]].[second [split $name .]].Enable]}
      }
#    if there is any reply other than 1 (enabled) then set the data source to be not enabled
      if {$enable != 1} then {set enable 0}

#    finally require the number of data bits 
      switch $module {
         Saphir   {set databits 13}
         ADC6414V {set databits 14}
         HRGe8x0  {set databits 14}
      }

      puts $f "[format "%-25s%-10s%-10s%-10s%-10s%-10s" $name $group $item $label $enable $databits]"
    }
 
    close $f
    clear-footer
}
