

#   csi.defn.tcl     CsI VXI card


proc {AddCsIModule}  {module slot}  {
   global registerbase cardtype nsockets

   set registerbase $cardtype#$module

   delete-vxi-registers $registerbase.*

   CsIVXIRegisters $slot
   CsIModuleRegisters $slot

   for {set socket 1} {$socket <= $nsockets} {incr socket} {

        set registerbase $cardtype[expr $module * $nsockets + $socket - 1]

        delete-vxi-registers $registerbase.*

#    first a register to record module each channel is in
        csi_register  ModuleName    generic "-n$cardtype#$module -tstring -pro"
   
        CsIVXIRegisters $slot
        CsIModuleRegisters $slot

        AddCsIDetector $slot $socket
   }
}

proc AddCsIDetector {slot socket} {
  CsIDetectorRegisters  $slot $socket
  CsISAROCRegisters $slot $socket
}

proc csi_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc CsIVXIRegisters {slot} {
   csi_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   csi_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   csi_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   csi_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   csi_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   csi_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   csi_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   csi_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   csi_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   csi_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   csi_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   csi_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   csi_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
}

proc CsIModuleRegisters {slot} {
   global registerbase

#    common area registers

        csi_register FT.Delay          xDAC "-s$slot -o0x00 -w16 -pwo -qn -us -d0 -r0:0us,0xff:2us -i125ns"
        csi_register Val.Delay         xDAC "-s$slot -o0x02 -w16 -pwo -qn -us -d0 -r0:0us,0xff:12us -i50ns"
        csi_register Int.Time          xDAC "-s$slot -o0x04 -w16 -pwo -qn -us -d0 -r0:3us,0xff:12us -i125ns"

        csi_register MCR               xDig "-s$slot -o0x10 -w16 -prw -fx -b0 -l0    "
        csi_register TFAGain           xDig "-s$slot -o0x10 -w16 -prw -fd -b0 -l2 -i3"
        csi_register SSEnable          xDig "-s$slot -o0x10 -w16 -prw -fd -b2 -l1 -i0"

        csi_register SS                xDig "-s$slot -o0x10 -w16 -prw -fd -b3 -l1 -i0"
        csi_register MasterMode        xDig "-s$slot -o0x10 -w16 -prw -fd -b4 -l1 -i0"

        csi_register FIFO.Reset        xDig "-s$slot -o0x10 -w16 -prw -fd -b8 -l1 -i1"
        csi_register GIR.Reset         xDig "-s$slot -o0x10 -w16 -prw -fd -b9 -l1    "
        csi_register LastCard          xDig "-s$slot -o0x10 -w16 -prw -fd -b10 -l1   "

        csi_register TestModeDisable   xDig "-s$slot -o0x10 -w16 -prw -fd -b11 -l1 -i1"

        csi_register PDMode            xDig "-s$slot -o0x10 -w16 -prw -fd -b12 -l2 -i0"

        csi_register Insp.D1.Channel   xMux "-s$slot -o0x20 -w16 -prw -b0 -l16 -dCsI -md1"
        csi_register Insp.D1.Signal    xDig "-s$slot -o0x22 -w16 -prw -fd -b0 -l0 -i0"
        csi_register Insp.D2.Channel   xMux "-s$slot -o0x24 -w16 -prw -b0 -l16 -dCsI -md2"
        csi_register Insp.D2.Signal    xDig "-s$slot -o0x26 -w16 -prw -fd -b0 -l0 -i0"
        csi_register Insp.A1.Channel   xMux "-s$slot -o0x28 -w16 -prw -b0 -l16 -dCsI -ma1"
        csi_register Insp.A1.Signal    xDig "-s$slot -o0x2a -w16 -prw -fd -b0 -l0 -i0"
        csi_register Insp.A2.Channel   xMux "-s$slot -o0x2c -w16 -prw -b0 -l16 -dCsI -ma2"
        csi_register Insp.A2.Signal    xDig "-s$slot -o0x2e -w16 -prw -fd -b0 -l0 -i0"
        csi_register Insp.V.Channel    xMux "-s$slot -o0x30 -w16 -prw -b0 -l16 -dCsI -mv"
        csi_register Insp.V.Signal     xDig "-s$slot -o0x32 -w16 -prw -fd -b0 -l0 -i0"

        csi_register ManID             xDig "-s$slot -o0x40 -w16 -prw -fx -b0 -l8    "
        csi_register SerialNum         xDig "-s$slot -o0x48 -w16 -prw -fx -b0 -l8    "
        csi_register ModLevel          xDig "-s$slot -o0x4a -w16 -prw -fx -b0 -l8    "


#    GIR registers

        csi_register GIR.EvNum.Count    xDig "-s$slot -o0xA0 -w16 -prw -fx -b0 -l0 -i0"
        csi_register GIR.EvNum.Addr     xAdr "-s$slot -c0 -o0xA2 -w16 -i$registerbase.GIR.EvNum"
        csi_register GIR.EvNum          xDig "-s$slot -o0xA0 -w32 -pro -fx -b0 -l0    "
        csi_register GIR.FIFO.Test      xFIT "-s$slot -o0xA4 -w32 -prw -fx"
        csi_register GIR.ROCR           xDig "-s$slot -o0xA8 -w16 -prw -fx -b0 -l0 -i0"
        csi_register GIR.ROTSR          xDig "-s$slot -o0xAC -w16 -pro -fx -b0 -l0    "
        csi_register GIR.ValAck.TimeOut xDAC "-s$slot -c0 -a0 -z0 -o0xAE -w16 -prw -qn -us -d0 -r0:0s,0xffff:4096000ns -i100000ns"
        csi_register GIR.Qstat0         xDig "-s$slot -o0xB0 -w32 -pro -fd -b0 -l16    "
        csi_register GIR.Qstat1         xDig "-s$slot -o0xB0 -w32 -pro -fd -b16 -l16    "

        csi_register GIR.ROCR.SAROC.Test           xDig "-s$slot -o0xA8 -w16 -prw -fx -b0 -l1    "
        csi_register GIR.ROCR.Ext.Test             xDig "-s$slot -o0xA8 -w16 -prw -fx -b1 -l1    "
        csi_register GIR.ROCR.ValAck.TimeOutReset  xDig "-s$slot -o0xA8 -w16 -prw -fx -b2 -l1    "
        csi_register GIR.ROCR.ReadOut.Disable      xDig "-s$slot -o0xA8 -w16 -prw -fx -b3 -l1    "
        csi_register GIR.ROCR.PipeLine.Enable      xDig "-s$slot -o0xA8 -w16 -prw -fx -b5 -l1    "
        csi_register GIR.ROCR.EvNumData.Disable    xDig "-s$slot -o0xA8 -w16 -prw -fx -b6 -l1    "
        csi_register GIR.ROCR.ReadOutMode          xDig "-s$slot -o0xA8 -w16 -prw -fx -b7 -l1 -i1"

        csi_register GIR.ROCR.Bit8                 xDig "-s$slot -o0xA8 -w16 -prw -fx -b8 -l1"
        csi_register GIR.ROCR.Bit9                 xDig "-s$slot -o0xA8 -w16 -prw -fx -b9 -l1"
        csi_register GIR.ROCR.Bit10                xDig "-s$slot -o0xA8 -w16 -prw -fx -b10 -l1"

        csi_register GIR.ROCR.EvNumQbits.Enable    xDig "-s$slot -o0xA8 -w16 -prw -fx -b11 -l1 -i1"

        csi_register GIR.ROTSR.Temp.Status            xDig "-s$slot -o0xAC -w16 -pro -fx -b0 -l8 "
        csi_register GIR.ROTSR.ValAck.TimeOut.Status  xDig "-s$slot -o0xAC -w16 -pro -fx -b8 -l1 "
        csi_register GIR.ROTSR.FIFO.Status            xDig "-s$slot -o0xAC -w16 -pro -fx -b9 -l2 "
        csi_register GIR.ROTSR.SAROC.Status           xDig "-s$slot -o0xAC -w16 -pro -fx -b11 -l1 "
        csi_register GIR.ROTSR.EvFault.Status         xDig "-s$slot -o0xAC -w16 -pro -fx -b13 -l3 "
}



proc CsISAROCRegisters {slot socket} {
   global registerbase

       if {$socket <= 4} then {
           set a 0x100
           set c [expr $socket - 1]
       } else {
           set a 0x180
           set c [expr $socket - 5]
       }

        csi_register   Energy.Addr        xAdr "-s$slot -c$c -a$a -z24 -o0x00 -w32 -i$registerbase.Energy"
        csi_register   Energy.TestData    xDig "-s$slot -c$c -a$a -z24 -o0x00 -w32 -prw -fx -b16 -l0"
        csi_register   Energy.TestRd      xDig "-s$slot -c$c -a$a -z24 -o0x00 -w32 -pro -fx -b16 -l0"
        csi_register   Energy.Thresh      xDig "-s$slot -c$c -a$a -z24 -o0x04 -w32 -g0 -prw -fd -b0 -l16 -i0"
        csi_register   Energy.ShiftCtrl   xDig "-s$slot -c$c -a$a -z24 -o0x04 -w32 -g0 -prw -fd -b16 -l2 -i1"
        csi_register   Energy.ROEnable    xDig "-s$slot -c$c -a$a -z24 -o0x04 -w32 -g0 -prw -fd -b18 -l1 -i1"
        csi_register   Energy.SSEnable    xDig "-s$slot -c$c -a$a -z24 -o0x04 -w32 -g0 -prw -fd -b19 -l1 -i1"
        csi_register   Energy.OSDisable   xDig "-s$slot -c$c -a$a -z24 -o0x04 -w32 -g0 -prw -fd -b20 -l1 -i0"

        csi_register   PI.Addr        xAdr "-s$slot -c$c -a$a -z24 -o0x08 -w32 -i$registerbase.PI"
        csi_register   PI.TestData    xDig "-s$slot -c$c -a$a -z24 -o0x08 -w32 -prw -fx -b16 -l0"
        csi_register   PI.TestRd      xDig "-s$slot -c$c -a$a -z24 -o0x08 -w32 -pro -fx -b16 -l0"
        csi_register   PI.Thresh      xDig "-s$slot -c$c -a$a -z24 -o0x0c -w32 -g0 -prw -fd -b0 -l16 -i0"
        csi_register   PI.ShiftCtrl   xDig "-s$slot -c$c -a$a -z24 -o0x0c -w32 -g0 -prw -fd -b16 -l2 -i1"
        csi_register   PI.ROEnable    xDig "-s$slot -c$c -a$a -z24 -o0x0c -w32 -g0 -prw -fd -b18 -l1 -i1"
        csi_register   PI.SSEnable    xDig "-s$slot -c$c -a$a -z24 -o0x0c -w32 -g0 -prw -fd -b19 -l1 -i1"
        csi_register   PI.OSDisable   xDig "-s$slot -c$c -a$a -z24 -o0x0c -w32 -g0 -prw -fd -b20 -l1 -i0"

        csi_register   Time.Addr        xAdr "-s$slot -c$c -a$a -z24 -o0x10 -w32 -i$registerbase.Time"
        csi_register   Time.TestData    xDig "-s$slot -c$c -a$a -z24 -o0x10 -w32 -prw -fx -b16 -l0"
        csi_register   Time.TestRd      xDig "-s$slot -c$c -a$a -z24 -o0x10 -w32 -pro -fx -b16 -l0"
        csi_register   Time.Thresh      xDig "-s$slot -c$c -a$a -z24 -o0x14 -w32 -g0 -prw -fd -b0 -l16 -i0"
        csi_register   Time.ShiftCtrl   xDig "-s$slot -c$c -a$a -z24 -o0x14 -w32 -g0 -prw -fd -b16 -l2 -i1"
        csi_register   Time.ROEnable    xDig "-s$slot -c$c -a$a -z24 -o0x14 -w32 -g0 -prw -fd -b18 -l1 -i1"
        csi_register   Time.SSEnable    xDig "-s$slot -c$c -a$a -z24 -o0x14 -w32 -g0 -prw -fd -b19 -l1 -i1"
        csi_register   Time.OSDisable   xDig "-s$slot -c$c -a$a -z24 -o0x14 -w32 -g0 -prw -fd -b20 -l1 -i0"
}

proc CsIDetectorRegisters {slot socket} {

        set c [expr $socket - 1]

        csi_register   PoleZero     xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x00 -g1 -w16 -pwo -fd -l8 -i128"
        csi_register   TimeAlign    xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x02 -g1 -w16 -pwo -fd -l8 -i128"
        csi_register   SigThresh    xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x04 -g1 -w16 -pwo -fd -l8 -i128"

        csi_register   CCR           xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -w16 -prw -fx -b0 -l0"
        csi_register   Enable        xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -w16 -prw -fd -b0 -l1 -i0"
        csi_register   TestGenEnable xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -w16 -prw -fd -b1 -l1 -i0"
}


proc CsI_DAQ-reset   {args}   {
   set module [first $args]
#    flush FIFOs
   write-vxi-register $module.FIFO.Reset 0
   write-vxi-register $module.FIFO.Reset 1
   write-vxi-register $module.FIFO.Reset 0
#    reset and enable GIR
   write-vxi-register $module.GIR.FIFO.Test 0
   read-vxi-register $module.GIR.FIFO.Test
}


proc CsI_DAQ-halt   {args}   {
   set module [first $args]
#    no action
}


proc CsI_DAQ-go   {args}   {
   set module [first $args]
#   initialise the SAROC control registers
   initialise-vxi-registers $module.*.ShiftCtrl
   initialise-vxi-registers $module.*.ROEnable
   initialise-vxi-registers $module.*.SSEnable
   initialise-vxi-registers $module.*.OSDisable
#    zero event numbers
   write-vxi-register $module.GIR.EvNum.Count 0
}
