# fvi.tcl    FERA-VXI Interface control

#  created 25-7-97  VP  from cluster bgo

set debug 0
set started 0

set frame FVI
set frametitle "FERA-VXI Interface Setup"
set icontitle  "FVI"

set cardtype FVI
set VXIGlobal ""

set chanlist {???}
set chanindex 0

set defaultchanlist {1 2}


#    data used to initialise unused entries of the LUT
set LUTinitdata 0x0cf7

#    The array "table" which is indexed by the "widget name" contains all the information
#    needed for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"

#    Module Control Register

set table(MCRMODE) {mcr0 int-widget->param param->int-widget "TestMode.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCRFTT) {mcr1 int-widget->param param->int-widget "FTTimeOut.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCRVALT) {mcr2 int-widget->param param->int-widget "VALTimeOut.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
#set table(MCR0) {mcr0 int-widget->param param->int-widget "TestMode.Enable"
#      int-reg->param param->int-reg nil nil nil nil nil 0 nil}
#set table(MCR1) {mcr1 int-widget->param param->int-widget "FTTimeOut.Enable"
#       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
#set table(MCR2) {mcr2 int-widget->param param->int-widget "VALTimeOut.Enable"
#       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCR3) {mcr3 int-widget->param param->int-widget "Reject.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCR5) {mcr5 int-widget->param param->int-widget "REQ1Reg.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCR6) {mcr6 int-widget->param param->int-widget "REQ2Reg.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCR7) {mcr7 int-widget->param param->int-widget "CDT.Enable"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCR8) {mcr8 int-widget->param param->int-widget "FIFO.Reset"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCR9) {mcr9 int-widget->param param->int-widget "GIR.Reset"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MCRA) {mcra int-widget->param param->int-widget "LastCard"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#   Module Status Register  (FVI STAT)
set table(MSR0) {msr0 int-widget->param param->int-widget "FVISTAT.bit0"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR1) {msr1 int-widget->param param->int-widget "FVISTAT.bit1"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR2) {msr2 int-widget->param param->int-widget "FVISTAT.bit2"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR3) {msr3 int-widget->param param->int-widget "FVISTAT.bit3"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR4) {msr4 int-widget->param param->int-widget "FVISTAT.bit4"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR5) {msr5 int-widget->param param->int-widget "FVISTAT.bit5"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR6) {msr6 int-widget->param param->int-widget "FVISTAT.bit6"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR7) {msr7 int-widget->param param->int-widget "FVISTAT.bit7"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR8) {msr8 int-widget->param param->int-widget "FVISTAT.bit8"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSR9) {msr9 int-widget->param param->int-widget "FVISTAT.bit9"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MSRA) {msra int-widget->param param->int-widget "FVISTAT.bitA"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#    common area
set table(TIMEOUT0) {timeout0 slider-widget->param param->int-widget "FT.TimeOut"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(TIMEOUT1) {timeout1 slider-widget->param param->int-widget "Val.TimeOut"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(FTDDELAY) {ftddelay slider-widget->param param->int-widget "FT.Delay"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(VALDDELAY) {valddelay slider-widget->param param->int-widget "Val.Delay"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(FTDWIDTH) {ftdwidth slider-widget->param param->int-widget "FT.Width"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(VALDWIDTH) {valdwidth slider-widget->param param->int-widget "Val.Width"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}

set table(FTCOUNT) {ftcount int-widget->param param->int-widget "FT.Counter"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VALCOUNT) {valcount int-widget->param param->int-widget "Val.Counter"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(TRIGCOUNT) {trigcount int-widget->param param->int-widget "AncTrig.Counter"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

set table(CLRFTCOUNT) {clrftcount int-widget->param param->int-widget "Clr.FTCounter"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CLRVALCOUNT) {clrvalcount int-widget->param param->int-widget "Clr.ValCounter"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(CLRTRIGCOUNT) {clrtrigcount int-widget->param param->int-widget "Clr.AncTrigCounter"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#    Channel 1 Setup
set table(TIMEOUT2) {timeout2 slider-widget->param param->int-widget "Chan1.TimeOut"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(REN1DELAY) {ren1delay slider-widget->param param->int-widget "Chan1.RENDelay"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(GATE1DELAY) {gate1delay slider-widget->param param->int-widget "Chan1.GateDelay"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(GATE1WIDTH) {gate1width slider-widget->param param->int-widget "Chan1.GateWidth"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(FERACTL10) {feractl10 int-widget->param param->int-widget "Chan1.FERACntrl0"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(FERACTL11) {feractl11 int-widget->param param->int-widget "Chan1.FERACntrl1"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(FERACTL12) {feractl12 int-widget->param param->int-widget "Chan1.FERACntrl2"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(FERACTL13) {feractl13 int-widget->param param->int-widget "Chan1.FERACntrl3"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(FERAFIFO1) {ferafifo1 int-widget->param param->hex-widget "Chan1.FERAFIFOData"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VSN1SEL1) {vsn1sel1 int-widget->param param->int-widget "Chan1.VSNSel1"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VSN1SEL2) {vsn1sel2 int-widget->param param->int-widget "Chan1.VSNSel2"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VSN1SEL3) {vsn1sel3 int-widget->param param->int-widget "Chan1.VSNSel3"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VSN1SEL4) {vsn1sel4 int-widget->param param->int-widget "Chan1.VSNSel4"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#    Channel 2 Setup
set table(TIMEOUT3) {timeout3 slider-widget->param param->int-widget "Chan2.TimeOut"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(REN2DELAY) {ren2delay slider-widget->param param->int-widget "Chan2.RENDelay"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(GATE2DELAY) {gate2delay slider-widget->param param->int-widget "Chan2.GateDelay"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(GATE2WIDTH) {gate2width slider-widget->param param->int-widget "Chan2.GateWidth"
       unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}
set table(FERACTL20) {feractl20 int-widget->param param->int-widget "Chan2.FERACntrl0"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(FERACTL21) {feractl21 int-widget->param param->int-widget "Chan2.FERACntrl1"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(FERACTL22) {feractl22 int-widget->param param->int-widget "Chan2.FERACntrl2"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(FERACTL23) {feractl23 int-widget->param param->int-widget "Chan2.FERACntrl3"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(FERAFIFO2) {ferafifo2 int-widget->param param->hex-widget "Chan2.FERAFIFOData"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VSN2SEL1) {vsn2sel1 int-widget->param param->int-widget "Chan2.VSNSel1"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VSN2SEL2) {vsn2sel2 int-widget->param param->int-widget "Chan2.VSNSel2"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VSN2SEL3) {vsn2sel3 int-widget->param param->int-widget "Chan2.VSNSel3"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(VSN2SEL4) {vsn2sel4 int-widget->param param->int-widget "Chan2.VSNSel4"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#    VXI Configuration Registers

set table(MODELCODE) {vximodcode str-widget->param param->hex-widget "VXI.ModelCode"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SERIALNUM) {vxiserialnum str-widget->param param->hex-widget "VXI.SerialNum"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MODLEVEL) {vximodlevel str-widget->param param->hex-widget "VXI.ModLevel"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MANID) {vximanid str-widget->param param->hex-widget "VXI.ManID"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(OFFSET) {vxioffset str-widget->param param->hex-widget "VXI.Offset"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(DEVICE) {vxidevice str-widget->param param->hex-widget "VXI.DevClass"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(ADDRSPACE) {vxiaddrspace str-widget->param param->hex-widget "VXI.AddrSpace"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(STATUS) {vxistatus str-widget->param param->hex-widget "VXI.Status"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#  Module (FVI) Configuration Registers

set table(BRDMODELCODE) {brdmodcode str-widget->param param->hex-widget "BRD.ModelCode"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(BRDSERIALNUM) {brdserialnum str-widget->param param->hex-widget "BRD.SerialNum"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(BRDMODLEVEL) {brdmodlevel str-widget->param param->hex-widget "BRD.ModLevel"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(BRDMANID) {brdmanid str-widget->param param->hex-widget "BRD.ManID"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}





#    register selection for parameter save function

set registersavepatterns {
  FT.TimeOut FT.Delay FT.Width Val.TimeOut Val.Delay Val.Width
  Chan1.TimeOut Chan1.RENDelay Chan1.GateDelay Chan1.GateWidth
  Chan2.TimeOut Chan2.RENDelay Chan2.GateDelay Chan2.GateWidth
  GIR.ValAck.TimeOut GIR.ROCR.ValAck.TimeOutReset
  FTTimeOut.Enable VALTimeOut.Enable
  CDT.Enable GIR.ROCR.ReadOutMode
  Chan1.VSNSel1 Chan1.VSNSel2 Chan1.VSNSel3 Chan1.VSNSel4
  Chan2.VSNSel1 Chan2.VSNSel2 Chan2.VSNSel3 Chan2.VSNSel4
  Chan1.FERACntrl Chan2.FERACntrl
}


# inspection tables must be in same order as entries in the :choice-stacks
# this is achieved by using these tables when generating the choices
# index number returned maps directly to the signal number to be written to
# the Signal Select register

#set insp_table(MUX-AI1) {"Insp.A1" AI}
#set insp_table(MUX-AI2) {"Insp.A2" AI}
set insp_table(MUX-DI1) {"Insp.D1" DI}
set insp_table(MUX-DI2) {"Insp.D2" DI}
set insp_table(MUX-VI)  {"Insp.V"  VI}

#set insp_menu(MUX-AI1) analogueinsptable
#set insp_menu(MUX-AI2) analogueinsptable
set insp_menu(MUX-DI1) digitalinsptable
set insp_menu(MUX-DI2) digitalinsptable
set insp_menu(MUX-VI)  voltageinsptable

#set inspection_widgetnames {MUX-AI1 MUX-AI2 MUX-DI1 MUX-DI2 MUX-VI}
#set inspection_regnames    {Insp.A1 Insp.A2 Insp.D1 Insp.D2 Insp.V}

set inspection_widgetnames {MUX-DI1 MUX-DI2 MUX-VI}
set inspection_regnames    {Insp.D1 Insp.D2 Insp.V}


#    the inspection line tables are in parallel
#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

#set analogueinsptable {Disconnected}
#set AI-ChanSelect {0}
#set AI-Param      {*}

set digitalinsptable {Disconnected WST_1 REN_1 GATE_2 WST_2 REN_2 GATE_1 Reset Inhibit Reject
        Trigger REQ_1 REQ_2 WST_1 READFIFO_1 READFIFO_2
        Fast_Trigger Inhibit Validation Veto FVI_Valack En_Int_Readout_TEST
        StartReadout Renin VXI_Readout End_Readout
        CSA*(FifoChipSelect_A) CLKA(FifoClock_A) ENA(FifoEnablePort_A)
        AS*(VME) DS(VME) R/W*(VME) ModRoco
        CardRenin* BLTACK(Card) BLTACK(Bus) OE_Ident*
        CSB*(FifoChipSelect_B) CLKB(FifoClock_B) ENB(FifoEnablePort_B) OR_Fifo(EmptyFlag)
        FDTACK DTACK*(VME) CardRenout SysClk LT_Reset* Readout_Event_Match Reset_Fifo* Decode_Sel
        Strobe_Dec2 Dclk DCS* DDin Coding_Bus Coding_GIR Event_Fault_more_than_one Readout_Event_Fault
}

set DI-ChanSelect {0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
                   32 32 32 32 32 32 32 32 32 32
                   32 32 32 32 32 32 32 32 32 32
                   32 32 32 32 32 32 32 32 32 32
                   32 32 32 32 32 32 32 32 32 32
                   32
}
set DI-Param      {* 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14
                   1 2 3 4 5 6 7 8 9 18
                   19 20 21 22 23 24 25 26 27 28
                   29 30 31 32 33 34 35 36 37 38
                   39 40 41 42 43 44 45 46 47 48
                   49
}

set voltageinsptable {Disconnected +5V Gnd -5.2V -2V}
set VI-ChanSelect {0 1 1 1 1}
set VI-Param      {* 0 1 2 3}

set digitalinspmenu {Disconnected WST_1 REN_1 GATE_2 WST_2 REN_2 GATE_1 Reset Inhibit Reject
        Trigger REQ_1 REQ_2 WST_1 READFIFO_1 READFIFO_2
        {"GIR lines #1" Fast_Trigger Inhibit Validation Veto FVI_Valack En_Int_Readout_TEST
        StartReadout Renin VXI_Readout End_Readout}
        {"GIR lines #2" CSA*(FifoChipSelect_A) CLKA(FifoClock_A) ENA(FifoEnablePort_A)
        AS*(VME) DS(VME) R/W*(VME) ModRoco
        CardRenin* BLTACK(Card) BLTACK(Bus) OE_Ident*
        CSB*(FifoChipSelect_B) CLKB(FifoClock_B) ENB(FifoEnablePort_B) OR_Fifo(EmptyFlag)
        FDTACK DTACK*(VME) CardRenout SysClk LT_Reset* Readout_Event_Match Reset_Fifo* Decode_Sel
        Strobe_Dec2 Dclk DCS* DDin Coding_Bus Coding_GIR Event_Fault_more_than_one Readout_Event_Fault}
}

#  The order of items in the following 2 lists is important

set InternalTestMenu [list "Simulate 250ns FT Pulse" \
                           "Simulate 250ns Validation Pulse" \
                           "Simulate 250ns Trig Pulse"]

set InternalTestRegs {Sim.FTPulse Sim.ValPulse Sim.TrigPulse}

loadsource gir
loadsource  common.vxi

#proc EG {args} {puts stdout "EG: ($args)" }

catch {set LUTdir "$env(EXPERIMENTBASE)"}

proc set-experiment dir {
   global env LUTdir
   set LUTdir "$env(EXPERIMENTBASE)"
}

#    write the FVI LUTs using data in the file previously written by CAMAC Control
#    only the used entries are written - the LUTs should be initialised with
#    a suitable value first

proc loadLUT {} {
   global EGreport chanindex allchans

  set SaveIt $EGreport
  set SaveC $chanindex
  set SaveA $allchans

  set EGreport -1
  set chanindex 0
  set allchans 0

  initLUT
  writeLUT

  set EGreport $SaveIt
  set chanindex $SaveC
  set allchans $SaveA
}

proc initLUT {} {
  global LUTinitdata LUToffset

   set LUToffset 0
   catch {:modify LUTOFFSET :value $LUToffset}
   set LUTtable 1
   set-footer "initialising LUT entries for LUT$LUTtable"
   write-vxi-attrib "Chan$LUTtable.LUT.DataAccess" "-o $LUToffset -l 16384 -i$LUTinitdata"
   init-vxi-reg "Chan$LUTtable.LUT.DataAccess"

   set LUTtable 2
   set-footer "initialising LUT entries for LUT$LUTtable"
   write-vxi-attrib "Chan$LUTtable.LUT.DataAccess" "-o $LUToffset -l 16384 -i$LUTinitdata"
   init-vxi-reg "Chan$LUTtable.LUT.DataAccess"

   clear-footer
}

proc writeLUT {} {
  global LUTdir chanlist chanindex
  set z [catch {open $LUTdir/LUT.fvi r} file]
  if {$z != 0} then {set-footer "$file"; return}
  set l [read $file]
  close $file
  set-footer "Writing FVI LUTs using data from $LUTdir/LUT.fvi"
  set-busy
  update
  foreach line [split $l \n] {
     if {[string range $line 0 5] == "module"} then {
         set chanindex [lsearch $chanlist [string range $line 7 7]]
         continue
     }
     set element [split [first $line] +]
     if {[string range [first $element] 0 2] != "lut"} then {continue}
     set luttable [string range [first $element] 3 end]
     set lutoffset [second $element]
     set item [second $line]
     set group [third $line]
     write-vxi-attrib Chan$luttable.LUT -o$lutoffset
     write-vxi-reg Chan$luttable.LUT [expr [expr $item << 8] + $group]
  }
  clear-busy
  clear-footer
}


set LUToffset 0
set LUTtable 1

proc showLUT {} {
   global LUToffset LUTtable EGreport

   set SAVE $EGreport
   set EGreport -1
   set-busy

   set frame "dump"
   :frame [self frame-name].$frame :label  "FVI Look Up Table Dump"  :transient T
   wm protocol [self frame-name].$frame WM_DELETE_WINDOW {destroy [self frame-name].dump}

   :galley LUTLIST :rows 52 :cols 80 :deaf T :strings ""  :font fixed
   :show T

#    empty display
   :modify LUTLIST :strings "FVI LUT $LUTtable display starting at offset $LUToffset for 512 bytes\n\n"
   update

   set offset $LUToffset
#    do a block read for 128 words
   write-vxi-attrib "Chan$LUTtable.LUT.DataAccess" "-o $offset -l 128"
   set LUT [read-vxi-reg "Chan$LUTtable.LUT.DataAccess"]
   for {set i 0} {$i < 16} {incr i} {
      if {[expr [expr $i / 2] * 2] == $i} then {:modify LUTLIST :strings "vsn [expr $offset / 32]\n"}
      :modify LUTLIST :strings "[format "%8s" $offset]"
      for {set j 0} {$j < 8} {incr j} {
        set vl [lindex $LUT [expr $i * 8 + $j]]
#    and add to display
        :modify LUTLIST :strings "[format "%8s" $vl]"
        incr offset 2
      }
   :modify LUTLIST :strings "\n"
   update
   }
  set offset [expr $LUToffset + 256]
#    do a block read for 128 words
   write-vxi-attrib "Chan$LUTtable.LUT.DataAccess" "-o $offset -l 128"
   set LUT [read-vxi-reg "Chan$LUTtable.LUT.DataAccess"]
   for {set i 0} {$i < 16} {incr i} {
      if {[expr [expr $i / 2] * 2] == $i} then {:modify LUTLIST :strings "vsn [expr $offset / 32]\n"}
      :modify LUTLIST :strings "[format "%8s" $offset]"
      for {set j 0} {$j < 8} {incr j} {
        set vl [lindex $LUT [expr $i * 8 + $j]]
#    and add to display
        :modify LUTLIST :strings "[format "%8s" $vl]"
        incr offset 2
      }
   :modify LUTLIST :strings "\n"
   update
   }


   :modify LUTLIST :see 0

   clear-busy
   set EGreport $SAVE
}

proc do-forceclear {} {
#    force the FVI to clear current event (and any inhibit)
    set mode [read-vxi-reg TestMode.Enable]
    set mcr [read-vxi-reg MCR]
#     set test + reject bits
    write-vxi-reg MCR [expr ($mcr & 0xfff0) + 9]
#     rewrite original state without reject bit
    write-vxi-reg MCR [expr $mcr & 0xfff7]
    click-redisplay
}

proc click arg {
   global debug chanlist allchans LUTtable LUToffset
   if {$debug} then {puts stderr "proc click called with argument \{$arg\}"}
#   insert-debug "proc click called with argument \{$arg\}"
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      CHANNEL     {click-channel $v}
      ALLCHANS    {
          set allchans $v
          if {[llength $chanlist] == 1} then {set allchans 0; :modify ALLCHANS :value 0}
          make-myserver
      }
      WRITELUT    {loadLUT}
      READLUT     {showLUT}
      LUTTABLE    {set LUTtable [expr $v + 1]}
      LUTOFFSET   {set LUToffset $i}

      EUROBALL    {click-on MCRMODE 1}
      DIAMANT     {click-on MCRMODE 0}
      FORCECLEAR  {do-forceclear}

      *REDISPLAY   {click-redisplay}
      ENGINEERING  {click-$v}
      MCRMSR      {click-controlstatus}
      RDCOUNTS    {update-pairs [read-regs "" "" *Counter]}
      CLRCOUNTS   {click-on CLRFTCOUNT 0; click-on CLRVALCOUNT 0; click-on CLRTRIGCOUNT 0}
      FERAFIFO1RD {update-pairs [read-regs "" "" Chan1.FERAFIFOData]}
      FERAFIFO2RD {update-pairs [read-regs "" "" Chan2.FERAFIFOData]}
      MCRRESET    {click-on MCR8 1; click-on MCR8 0}

      GIR*         {click-GIRwindow $w $v}

      MUX-*  {click-inspection $w [lindex $arg 4]}

      default   {click-on $w $v}
   }
}


set electronicsframe   "[self frame-name].electronics"
set controlstatusframe "[self frame-name].controlstatus"

proc make-frame1 {} {
  global env chanlist analogueinsptable digitalinspmenu voltageinsptable 

  :frame "[self frame-name]" :label "[self frame-title]" :show-footer T  :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

    :panel PANEL1 :layout T :padx 10 :pady 5
      :layout H; :row-gap 5; :col-gap 10

      :choice-stack CHANNEL :label Module: :valuex 8c :strings $chanlist
      :checkbox ALLCHANS    :label "Act on all Modules:" 
      :next-row T

      :message COMMON    :label "Common Setup" :bold T :valuex 25c
      :next-row T
      :slider TIMEOUT0   :label "FT timeout (nSec)"     :min 0 :max 5000 :resolution 500 :valuex 25c
      :slider TIMEOUT1   :label "VAL timeout (nSec)"    :min 0 :max 15000 :resolution 500 :valuex 26c
      :next-row T
      :slider FTDDELAY   :label "FT => FTD (nSec)"    :min 0 :max 20000 :resolution 10 :valuex 25c
      :slider VALDDELAY  :label "VAL => VALD (nSec)"  :min 0 :max 20000 :resolution 10 :valuex 25c
      :next-row T
      :slider FTDWIDTH   :label "FTD width (nSec)"  :min 0 :max 20000 :resolution 10 :valuex 25c
      :slider VALDWIDTH  :label "VALD width (nSec)" :min 0 :max 20000 :resolution 10 :valuex 25c
      :next-row T
      :text   FTCOUNT    :label "Fast Triger counter"     :w 12
      :text   VALCOUNT   :label "Validation counter"      :w 12
      :text   TRIGCOUNT  :label "Ancillary TRIG counter"  :w 12
      :button RDCOUNTS   :label "Update"
      :button CLRCOUNTS  :label "Clear"
      :next-row T
      :col-gap 25
      :checkbox MCRFTT    :label "FT Timeout Enable"   :valuex 25c
      :checkbox MCRVALT   :label "VAL Timeout Enable"  :valuex 52c

    :panel PANEL2 :layout L :padx 10
     :layout V; :col-gap 5; :row-gap 5

      :message CHAN1 :label "Channel 1 Setup" :bold T :valuex 25c
      :slider TIMEOUT2   :label "Request timeout (nSec)" :min 0 :max 30000 :resolution 500 :valuex 25c
      :slider REN1DELAY  :label "REQUEST => REN (nSec)"  :min 0 :max 50000 :resolution 100 :valuex 25c
      :slider GATE1DELAY :label "TRIG => GATE (nSec)"    :min 0 :max 20000 :resolution 10  :valuex 25c
      :slider GATE1WIDTH :label "Gate width (nSec)"      :min 0 :max 20000 :resolution 10  :valuex 25c
      :layout H
      :next-row T
      :vskip 10
      :number VSN1SEL1   :label "VSN select (LeCroy)"    :value 0 :min 0 :max 255 :w 4 :valuex 20c
      :number VSN1SEL2   :label "VSN select (Ganelec)"   :value 0 :min 0 :max 255 :w 4 :valuex 20c
      :next-row T
      :number VSN1SEL3   :label "VSN select (Silena)"    :value 0 :min 0 :max 255 :w 4 :valuex 20c
      :number VSN1SEL4   :label "VSN select (Ortec)"     :value 0 :min 0 :max 255 :w 4 :valuex 20c

    :panel PANEL3 :layout L :padx 10
     :layout V; :col-gap 5; :row-gap 5

      :message CHAN2 :label "Channel 2 Setup" :bold T :valuex 25c
      :slider TIMEOUT3   :label "Request timeout (nSec)" :min 0 :max 30000 :resolution 500 :valuex 25c
      :slider REN2DELAY  :label "REQUEST => REN (nSec)"  :min 0 :max 50000 :resolution 100 :valuex 25c
      :slider GATE2DELAY :label "TRIG => GATE (nSec)"    :min 0 :max 20000 :resolution 10  :valuex 25c
      :slider GATE2WIDTH :label "Gate width (nSec)"      :min 0 :max 20000 :resolution 10  :valuex 25c
      :layout H
      :next-row T
      :vskip 10
      :number VSN2SEL1   :label "VSN select (LeCroy)"    :value 0 :min 0 :max 255 :w 4 :valuex 20c
      :number VSN2SEL2   :label "VSN select (Ganelec)"   :value 0 :min 0 :max 255 :w 4 :valuex 20c
      :next-row T
      :number VSN2SEL3   :label "VSN select (Silena)"    :value 0 :min 0 :max 255 :w 4 :valuex 20c
      :number VSN2SEL4   :label "VSN select (Ortec)"     :value 0 :min 0 :max 255 :w 4 :valuex 20c

#    panels working from bottom of the frame up

   :panel PANEL6  :layout B :padx 10 :after FOOTER
    :layout H; :col-gap 10; :row-gap 10
      :button WRITELUT   :label "Write All LUTs"
      :button READLUT    :label "Show LUT"
      :choice LUTTABLE   :label ""  :strings [list 1 2]
      :choice-stack LUTOFFSET :label "" :strings [list 0 512 1024 1536 2048 2560 3072 3584 4096 4608 5120 5632 6144 6656 7168 7860]
      :hskip 25
      :button FORCECLEAR  :label "Force Clear"
      :button EUROBALL    :label "Euroball Only Operation"
      :button DIAMANT     :label "Euroball + FVI Operation"
      :next-row T
      :button REDISPLAY
      :hskip 50
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      GIRbutton
      :button MCRMSR      :label "Module Control/Status & Tests"
      :hskip 50
      :button HELP          :command click-help

    :panel PANEL5 :layout B :padx 10 :pady 10 :after PANEL6
      :layout H; :col-gap 10; :row-gap 10
#      :menubutton MUX-AI1 :label "Analogue Inspection 1:" :w 20 :menu $analogueinsptable
#      :message MUX-AI1-USE   :label ""
#      :next-row T
#      :menubutton MUX-AI2 :label "Analogue Inspection 2:" :w 20 :menu $analogueinsptable
#      :message MUX-AI2-USE   :label ""
#      :next-row T
      :menubutton MUX-DI1 :label "Digital Inspection 1:"  :w 20 :menu $digitalinspmenu
      :message MUX-DI1-USE   :label ""
      :next-row T
      :menubutton MUX-DI2 :label "Digital Inspection 2:"  :w 20 :menu $digitalinspmenu
      :message MUX-DI2-USE   :label ""
      :next-row T
      :menubutton MUX-VI  :label "Voltage Inspection:"    :w 20 :menu $voltageinsptable
      :message MUX-VI-USE   :label ""

   :show T
}


proc click-controlstatus {} {
   global controlstatusvisible controlstatusframe
   if {$controlstatusvisible==0} then {make-controlstatus} else {open-frame $controlstatusframe}
   click-redisplay
}

set controlstatusvisible 0

proc make-controlstatus {} {
  global env controlstatusframe controlstatusvisible
  global InternalTestMenu

  :frame "$controlstatusframe" :label "FVI Control & Status Registers and Module Tests" :show-footer T :resize F :transient T

    :panel MCRPANEL :layout L :padx 5 :pady 5
     :layout V; :row-gap 5

      :message CSM1       :label "Module Control Register" :bold T
      :choice MCRMODE     :label "Mode" :strings [list Normal Test] :valuex 20c
#      :checkbox MCR1   :label "FT Timeout Enable"  :valuex 20c
#      :checkbox MCR2   :label "VAL Timeout Enable"  :valuex 20c
      :checkbox MCR3   :label "Reject On"   :valuex 20c
      :checkbox MCR5   :label "Branch 1 REQ On"   :valuex 20c
      :checkbox MCR6   :label "Branch 2 REQ On"   :valuex 20c
      :checkbox MCR7   :label "Common deadtime mode"  :valuex 20c
      :choice   MCR8   :label "" :strings [list "Reset FVI and Anc Trig Off" "Reset FVI and Anc Trig On"]
      :checkbox MCR9   :label "GIR Reset"  :deaf T  :valuex 20c
      :checkbox MCRA   :label "Last Card"  :deaf T  :valuex 20c

    :panel MSRPANEL :layout L :padx 5 :pady 5
     :layout V; :row-gap 5

      :message CSM2          :label "Module Status Register" :bold T
      :choice   MSR0   :label "Mode" :strings [list "Normal Mode" "Test Mode"] :deaf T  :valuex 8c
      :checkbox MSR1   :label "Branch 1 FIFO empty"  :deaf T  :valuex 20c
      :checkbox MSR2   :label "Branch 2 FIFO empty"  :deaf T  :valuex 20c
      :checkbox MSR3   :label "Branch 1 FIFO half full"  :deaf T  :valuex 20c
      :checkbox MSR4   :label "Branch 2 FIFO half full"  :deaf T  :valuex 20c
      :checkbox MSR5   :label "Branch 1 FIFO full"  :deaf T  :valuex 20c
      :checkbox MSR6   :label "Branch 2 FIFO full"  :deaf T  :valuex 20c
      :checkbox MSR7   :label "Inhibit asserted"  :deaf T  :valuex 20c
      :checkbox MSR8   :label "Reject asserted"  :deaf T  :valuex 20c
      :checkbox MSR9   :label "GIR Reset"  :deaf T  :valuex 20c
      :checkbox MSRA   :label "Last Card"  :deaf T  :valuex 20c

    :panel EXPANEL1 :layout B :padx 10  :after FOOTER
     :layout V; :col-gap 5; :row-gap 5

      :message EXCHAN1 :label "Channel 1 Setup" :bold T :valuex 25c
      :choice FERACTL10   :label "FERA control" \
           :strings [list "Do not clear ADCs" "Clear ADCs"]
      :choice FERACTL11   :label "FERA control" \
           :strings [list "Sequential readout" "Random readout"]
      :choice FERACTL12   :label "FERA control" \
           :strings [list "Do not hold data in FERA fifo" "Hold data in FERA fifo"]
      :choice FERACTL13   :label "FERA control" \
           :strings [list "FERA branch ON" "FERA branch OFF"]
      :text FERAFIFO1  :label "FERA FIFO Data"  :w 12 :valuex 18c
      :layout H
      :button FERAFIFO1RD :label "read"

    :panel EXPANEL2 :layout B :padx 10 :after FOOTER
     :layout V; :col-gap 5; :row-gap 5

      :message EXCHAN2 :label "Channel 2 Setup" :bold T :valuex 25c
      :choice FERACTL20   :label "FERA control" \
           :strings [list "Do not clear ADCs" "Clear ADCs"]
      :choice FERACTL21   :label "FERA control" \
           :strings [list "Sequential readout" "Random readout"]
      :choice FERACTL22   :label "FERA control" \
           :strings [list "Do not hold data in FERA fifo" "Hold data in FERA fifo"]
      :choice FERACTL23   :label "FERA control" \
           :strings [list "FERA branch ON" "FERA branch OFF"]
      :text FERAFIFO2  :label "FERA FIFO Data"    :w 12 :valuex 18c
      :layout H
      :button FERAFIFO2RD :label "read"

   :panel EXPANEL6  :layout B :padx 10 :pady 10 :after FOOTER
    :layout H; :col-gap 10; :row-gap 10

      :button EXREDISPLAY :label Redisplay
      :menubutton INTTESTS  :label "Internal Tests" :strings $InternalTestMenu

      :show T
   set controlstatusvisible 1
}

proc make-electronics {} {
  global env electronicsframe electronicsvisible

  :frame "$electronicsframe" :label "FVI Electronics" :show-footer T :resize F :transient T

    :panel ELECPANEL :layout T :padx 5 :pady 5
     :layout V; :row-gap 5

      :message ELM1       :label "VXI Configuration Registers (G.I.R)" :bold T
      :text MANID         :label "Manufacturer ID:"    :w 6  :read-only T   :valuex 20c
      :text DEVICE        :label "Device Class:"       :w 6  :read-only T   :valuex 20c
      :text ADDRSPACE     :label "Address Space:"      :w 6  :read-only T   :valuex 20c
      :text MODELCODE     :label "Model Code:"         :w 6  :read-only T   :valuex 20c
      :text SERIALNUM     :label "Serial Number:"      :w 6  :read-only T   :valuex 20c
      :text MODLEVEL      :label "Modification Level:" :w 6  :read-only T   :valuex 20c
      :text STATUS        :label "Status Register"     :w 6  :read-only T   :valuex 20c
      :text OFFSET        :label "Offset Register"     :w 6  :read-only T   :valuex 20c

      :vskip 10

      :message ELM2          :label "Module Configuration Registers (FVI)" :bold T
      :text BRDMANID         :label "Manufacturer ID:"    :w 6  :read-only T   :valuex 20c
      :text BRDMODELCODE     :label "Model Code:"         :w 6  :read-only T   :valuex 20c
      :text BRDSERIALNUM     :label "Serial Number:"      :w 6  :read-only T   :valuex 20c
      :text BRDMODLEVEL      :label "Modification Level:" :w 6  :read-only T   :valuex 20c

      :show T
   set electronicsvisible 1
}


#proc make-chanlist {} {}
#proc make-myserver {} {}
#proc click-redisplay {} {}
