# gir.tcl    used by all modules having GIR readout

#  12-08-96   VP   first version 

#    25-03-99   modification in order to include gir task

#    if task is "gir" we load sources from the gir sub-directory
if {$mytaskname == "gir"} then {loadsource gir/progdsp; return}

switch $mytaskname {
    ess -
    hrge8x -
    saphir -
    clusterbgo  -
    clusterge    {


#    first versions of these procs are for cards with a GIR including DSP

proc GIRbutton {} {
      :menubutton GIR         :label "GIR"          :strings [list "GIR Status" "GIR Control"] :command click-GIR
}

proc start-GIR {} {
#  display GIR sub frame
   global girvisible girframe
   if {$girvisible==0} then {make-GIR} else {open-frame $girframe}
   click-redisplay
} 

proc click-GIR {w c i} {
   global cardtype 
   switch $c {
      "GIR Status"      {start-GIR}
      "GIR Control"     {inform gir "start_with_card $cardtype"}
   }
}


#    end of switch case for cards having a GIR including DSP
}

    default      {

#    cards having a GIR without DSP continue (original case)

proc GIRbutton {} {
      :button GIR         :label "GIR"   :command start-GIR
}

proc start-GIR {} {
#  display GIR sub frame
   global girvisible girframe
   if {$girvisible==0} then {make-GIR} else {open-frame $girframe}
   click-redisplay
} 

#    end of switch case for cards having a GIR but NO DSP
}
}
# end of switch statement


#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(GIREVNUMADDR)    {girevnumaddr     int-widget->param param->hex-widget "GIR.EvNum.Addr"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIREVNUMCOUNT)    {girevnumcount    int-widget->param param->hex-widget "GIR.EvNum.Count"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRQSTAT0)    {girqstat0    int-widget->param param->hex-widget "GIR.Qstat0"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRQSTAT1)    {girqstat1    int-widget->param param->hex-widget "GIR.Qstat1"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROCRREADOUTMODE)     {girreadoutmode     logic-widget->param param->logic-widget "GIR.ROCR.ReadOutMode"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREVNUMDATADISABLE) {girevnumdatadisable logic-widget->param param->logic-widget "GIR.ROCR.EvNumData.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREVNUMQBITSENABLE) {girevnumqbitsenable logic-widget->param param->logic-widget "GIR.ROCR.EvNumQbits.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREXTTEST) {girexttest logic-widget->param param->logic-widget "GIR.ROCR.Ext.Test"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRPIPELINEENABLE) {girpipelineenable logic-widget->param param->logic-widget "GIR.ROCR.PipeLine.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRREADOUTDISABLE)     {girreadoutdisable     logic-widget->param param->logic-widget "GIR.ROCR.ReadOut.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRSAROCTEST) {girsaroctest logic-widget->param param->logic-widget "GIR.ROCR.SAROC.Test"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRVALACKTIMEOUTRESET) {girrocrvalacktimeoutreset logic-widget->param param->logic-widget "GIR.ROCR.ValAck.TimeOutReset"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}


#set table(GIRROCRBIT8) {girrocrbit8 logic-widget->param param->logic-widget "GIR.ROCR.Bit8"
#                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
#set table(GIRROCRBIT9) {girrocrbit9 logic-widget->param param->logic-widget "GIR.ROCR.Bit9"
#                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
#set table(GIRROCRBIT10) {girrocrbit10 logic-widget->param param->logic-widget "GIR.ROCR.Bit10"
#                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROTSREVFAULTSTATUS)    {girrotsrevfaultstatus    int-widget->param param->hex-widget "GIR.ROTSR.EvFault.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRFIFOSTATUS)    {girrotsrfifostatus    int-widget->param param->hex-widget "GIR.ROTSR.FIFO.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRSAROCSTATUS)    {girrotsrsarocstatus    logic-widget->param param->logic-widget "GIR.ROTSR.SAROC.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTempSTATUS)    {girrotsrtempstatus    int-widget->param param->hex-widget "GIR.ROTSR.Temp.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRVALACKTIMEOUTSTATUS) {girrotsrvalacktimeoutstatus  logic-widget->param param->logic-widget "GIR.ROTSR.ValAck.TimeOut.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRVALACKTIMEOUT)    {girvalacktimeout    slider-widget->param param->int-widget "GIR.ValAck.TimeOut"
                     unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}


set girframe [self frame-name].gir
set girvisible 0

proc click-GIRwindow  {w v} {
    switch -glob $w {
      GIRVALACKTIMEOUT -
      GIRROCR*    -
      GIRROTSR*    {click-on $w $v}
   }
}

proc make-GIR {} {
  global env girvisible girframe

set col1 40c

  :frame $girframe :label "GIR" :show-footer T :resize F :transient T 

  :panel PANEL1 :layout T :padx 5 :pady 5
    :layout V; :row-gap 5; :col-gap 5

      :text     GIREVNUMADDR     :label "Event Number Address:"  :valuex $col1 :w 6  :deaf T
      :text     GIREVNUMCOUNT    :label "Event Number Counter:"  :valuex $col1 :w 6
      :text     GIRQSTAT0        :label "Qstat0 Counter:"        :valuex $col1 :w 6
      :text     GIRQSTAT1        :label "Qstat1 Counter:"        :valuex $col1 :w 6

      :vskip 10
      :message M1 :label "Readout Control Register" :bold T
      :choice GIRROCRREADOUTMODE         :label "Read Out Mode" :valuex 25c  \
          :strings [list "Common Dead Time" "Parallel"]
      :checkbox GIRROCREVNUMDATADISABLE   :label "Event Number Readout Disable:"          :valuex $col1
      :checkbox GIRROCREVNUMQBITSENABLE  :label "Use Event Number Qbits:"               :valuex $col1
      :checkbox GIRROCREXTTEST           :label "Test Mode for External readout:"       :valuex $col1
      :checkbox GIRROCRSAROCTEST         :label "Test Mode for SAROC readout:"          :valuex $col1
      :checkbox GIRROCRPIPELINEENABLE     :label "Pipeline readout enable:"              :valuex $col1
      :checkbox GIRROCRREADOUTDISABLE    :label "GIR Readout Disable:"                  :valuex $col1
      :checkbox GIRROCRVALACKTIMEOUTRESET :label "Enable Valack Timeout Reset"          :valuex $col1

#      :checkbox GIRROCRBIT8  :label "Bit 8"          :valuex $col1
#      :checkbox GIRROCRBIT9  :label "Bit 9"          :valuex $col1
#      :checkbox GIRROCRBIT10 :label "Bit 10"          :valuex $col1

      :vskip 10
      :message M2 :label "Readout and Temperature Status Register"  :bold T
      :text    GIRROTSREVFAULTSTATUS     :label "Event Number fault Status:"   :valuex $col1 :w 6
      :text    GIRROTSRFIFOSTATUS        :label "FIFOs Status:"                :valuex $col1 :w 6
      :text    GIRROTSRTEMPSTATUS        :label "Temperature Sensor Status:"   :valuex $col1 :w 6
      :checkbox GIRROTSRSAROCSTATUS      :label "SAROC not empty:"             :valuex $col1 :deaf T
      :checkbox GIRROTSRVALACKTIMEOUTSTATUS     :label "ValAck Timeout Asserted:"       :valuex $col1 :deaf T
        
      :slider  GIRVALACKTIMEOUT          :label "ValAck Timeout (ns):"  :min 0 :max 4000000 :resolution 63

  :panel BUTTONS :layout B :padx 5 :after FOOTER
      :layout H
      :button GIRREDISPLAY  :label Redisplay  :command click-redisplay

  :show T
  set girvisible 1
}

