#    part of the Diagnostic task for testing GIR DSP functions
#    this is polezero.tcl

#    the global variable dsp is dependent on the GIR version fitted
#    it is set when the slot is selected

  set pzdac 128

set Listvoie [list A B C D E F G H]

   :frame [self frame-name].pz :label "Pole Zero Adjustment"  :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module"  \
      :icon-name "[self icon-title]"  :resize F

     :panel PZP4 :layout T :padx 10 :pady 10
      :layout H; :col-gap 8

      foreach voie {0 1 2 3 4 5 6 7} {
        :checkbox PZR$voie  :label "[lindex $Listvoie $voie]"  :w 8
         set pzvar($voie) 0
     					}

     :panel PZP0  :layout T :padx 10  :pady 10
      :layout V;  :col-gap 10
      :button PZAUTO   :label Auto   :w 8
      :message PZM1 :label "PZ Adjustment Report" :bold T
      :galley PZREPORT :rows 10 :cols 40 :deaf T

    :panel SPECTREPA0 :layout T :padx 10 :pady 5
     :layout H; :col-gap 5; :row-gap 5
     :button INFO	:label "Info"   :w 4 
     :button PZQUIT :label "Quit"   :w 4

     :show T

#####################
proc click-pzquit {args} {
   click-quit [self frame-name].pz
}
#####################
proc click-pzr {w v} {
   global pzvar
   set voie [string range $w 3 end]
   set pzvar($voie) $v
}

#####################
proc click-pzauto args {
   global pzvar

   :modify PZREPORT :empty T

   foreach voie {0 1 2 3 4 5 6 7} {
      if {$pzvar($voie) == 1} then {
    write-vxi-register $CurrentVXIModule.GIR.DSP.StopDSP 1
    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1

         log "Adjustment of PoleZero for channel $voie"
         AdjustPZ $voie
      }
   }
}

#####################
proc click-pzdac {v} {global pzdac;  set pzdac $v}

#####################
proc click-pzplot args {
   global girversion
    write-vxi-register $CurrentVXIModule.GIR.DSP.StopDSP 1
#   if {$girversion == 3} then {wrl $dsp+0xbff44 0x10000}
   Graph4MeV
}
#####################
proc click-info {args} {
   global TclBase
   midas-show-file  "$TclBase/info/explpz"  
			}






#    procedures Read4MeV,  Graph4mev and Adjustpz  moved from polezero.c

proc report {string} {:modify PZREPORT :strings $string\n}

proc Graph4MeV {} {
  global dsp girversion server slot

   set-footer [self frame-name].pz "Reading spectrum data from $server"
   midas-check-for-temp
   set z [catch {open hist4mev.dat w} f]
   if {$z != 0} then {midas-warning $f; clear-footer [self frame-name].pz; return}

   switch $girversion {
      4   {set base4mev [expr $dsp + (0x27300*4)]}
      3   {set base4mev [expr $sram + (0x7fe8e*4)]}
   }
   set nb4mev 100

   for {set i 0} {$i < $nb4mev} {incr i} {
      set data_read [rdl $base4mev+($i*4)]
      puts $f $data_read
   }
   close $f

   set-footer [self frame-name].pz "Converting data into a spectrum file"
   set f [file join [pwd] hist4mev.$server.s$slot]
   set z [catch {exec ascii-to-eg -from hist4mev.dat -to $f -format y} msg]
   log "$msg"
   inform sd show $f
   set-footer [self frame-name].pz "Spectrum files in $f"
}


proc Read4mev {} {
   global dsp girversion
   switch $girversion {
      4   {set base4mev [expr $dsp + (0x27300*4)]}
      3   {set base4mev [expr $sram + (0x7fe8e*4)]}
   }
   for {set i 0} {$i < 100} {incr i} {
      set data4mev [rdl $base4mev+($i*4)]
      set data_volt [expr (5*($data4mev - 0.5) - 640)/256]
      log "address:  $i = $data_volt"
   }
}

proc AdjustPZ {voie} {
   global dsp girversion Testing sram offset34

   set pz0 0x1004
   switch $girversion {
      4   {set base4mev [expr $dsp + (0x27300*4)]}
      3   {set base4mev [expr $sram + (0x7fe8e*4)]}
   }

   set muxa1 0x28
   set para1 0x2a


   set dacpz 200
   set deltapz 64
   set data 128
   set pz [expr $pz0 + ($voie * 0x100)]
   set varmuxa1 [expr $voie + 1]

   wrw $muxa1 $varmuxa1
   wrw $para1 0
   wrw $pz $dacpz 1



while { $deltapz > 1 && $dacpz <255 && $dacpz >= 0 && $data != 0} {

	set m 0
    write-vxi-register $CurrentVXIModule.GIR.DSP.StartPZ 1
#        wrl $dsp+0xbff40 0x40*$offset34 1
             taskDelay 10
    write-vxi-register $CurrentVXIModule.GIR.DSP.StopDSP 1
#       if {$girversion==3} {wrl $dsp+0xbff44 0x10000 1}
             taskDelay 10
            
      for {set i 0} {$i < 40} {incr i} {
	set k 0

        set data [rdl $base4mev+($i*4)]
         if {$data < 128 && $data != 0} {incr k}

         set data [rdl $base4mev+($i*8)]
         if {$data < 128 && $data != 0} {incr k}

	if {$k > 1} {incr m}
					}

if {$m > 2 } then {set dacpz [expr ($dacpz-$deltapz)]}	 \
	else {set deltapz [expr ($deltapz*0.5)]
		set dacpz [expr ($dacpz+$deltapz)]
		}

         wrw $pz $dacpz 1
log "m=$m, deltapz=$deltapz, dacpz=$dacpz"
		}

   if { $data == 0} then {report "no pulse detected in channel $voie"} \
     else {report "DAC value in channel $voie = $dacpz"}
}
