#    part of the Diagnostic task for testing GIR DSP functions
#    this is regdsp.tcl

#    the global variable dsp is dependent on the GIR version fitted
#    it is set when the slot is selected
global moduleindex card CurrentVXIModule

  :frame [self frame-name].regdsp :label "DSP Registers" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

    :panel REGDSPP1 :layout T :padx 10 :pady 10
    :layout H; :col-gap 10; :row-gap 10

    :button REGDSPSTATUS  :label "Status" :w 8
    :button REGDSPEXPL    :label "Expl"   :w 8

    :next-row T
    :layout V

    :show T

set regdspstateexists 0
set tdsp 0xc00000

proc click-regdspexpl args {
   global TclBase
   midas-show-file  "$TclBase/info/explregdsp"
}

proc click-regdspstatus args {
   global regdspstateexists regdspinfoexists CurrentVXIModule moduleindex card
   global dsp girversion tdsp

   if {$regdspstateexists == 0} then {:galley REGDSPSTATE :rows 16 :cols 30 :deaf T}
   set regdspstateexists 1
   :modify REGDSPSTATE :append F
   :modify REGDSPSTATE :strings "CURRENT MODULE : $moduleindex\n"
   :modify REGDSPSTATE :strings "CURRENT CARD :   $card\n"
   :modify REGDSPSTATE :strings "\n"

   array set nomreg {0 "SYSCON" 1 "WAIT" 2 "DMAC7" 3 "C7" 4 "EC7" 5 "LCTL" 6 "LCOM"}
	set length 6
   array set nomtreg {0 "TSYSCON" 1 "TWAIT" 2 "TDMAC7" 3 "TC7" 4 "TEC7" 5 "TLCTL" 6 "TLCOM"}

#     The action which follows is dependent on the GIR version

   switch $girversion {

      5 -
      4 {

         set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.Syscon]

if {($data_stat == 0x0)} then { 
set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.Syscon]}
         :modify REGDSPSTATE :strings "[format "SYSCON = 0x%x" $data_stat]\n"

         set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.Wait]
if {($data_stat == 0x0)} then { 
set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.Wait]}
         :modify REGDSPSTATE :strings "[format "WAIT = 0x%x" $data_stat]\n"

         set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.DMAC7]
         :modify REGDSPSTATE :strings "[format "DMAC7 = 0x%x" $data_stat]\n"

         set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.C7]
         :modify REGDSPSTATE :strings "[format "C7 = 0x%x" $data_stat]\n"

         set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.EC7]
         :modify REGDSPSTATE :strings "[format "EC7 = 0x%x" $data_stat]\n"

         set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.LCTL]
         :modify REGDSPSTATE :strings "[format "LCTL = 0x%x" $data_stat]\n"

         set data_stat [read-vxi-register $CurrentVXIModule.GIR.DSP.LCOM]
         :modify REGDSPSTATE :strings "[format "LCOM = 0x%x" $data_stat]\n"
 
        :modify REGDSPSTATE :strings "\n"

switch $card {
ClusterBGO {
         set data_stat [rdl $tdsp]
         :modify REGDSPSTATE :strings "TSYSCON = $data_stat\n"

         set data_stat [rdl "$tdsp + (0x2*4)"]
         :modify REGDSPSTATE :strings "TWAIT= $data_stat\n"

         set data_stat [rdl "$tdsp + (0x1d*4)"]
         :modify REGDSPSTATE :strings "TDMAC7 = $data_stat\n"

         set data_stat [rdl "$tdsp + (0x4a*4)"]
         :modify REGDSPSTATE :strings "TC7 = $data_stat\n"

         set data_stat [rdl "$tdsp + (0x4f*4)"]
         :modify REGDSPSTATE :strings "TEC7 = $data_stat\n"

         set data_stat [rdl "$tdsp + (0xc6*4)"]
         :modify REGDSPSTATE :strings "TLCTL = $data_stat\n"

         set data_stat [rdl "$tdsp + (0xc7*4)"]
         :modify REGDSPSTATE :strings "TLCOM = $data_stat\n"
}
}

        }

      3 {

         write-vxi-register $CurrentVXIModule.GIR.DSP.Mirror 0x1
	after 150

        set basestat [expr (0x7fff0*4)]
      	modify-vxi-register $CurrentVXIModule.GIR.DSP.ExtMem "-o $basestat -l $length"	
      	set DataRAM [read-vxi-register $CurrentVXIModule.GIR.DSP.ExtMem]
	set i 0

       foreach word $DataRAM {
:modify REGDSPSTATE :strings "[format "%s   :   0x%x" $nomreg($i) $word]\n"
incr i}
      	}
   		}

}
