#    part of the Diagnostic task for testing GIR DSP functions
#    this is sramtest.tcl

#    the global variable dsp is dependent on the GIR version fitted 
#    it is set when the slot is selected

global moduleindex card

set wait 0



  :frame [self frame-name].sram :label "Test External Memory" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

    :panel SRAMP3 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 10
     :text     MODULE    :label "Current MODULE:" :deaf T :w 4 :bold T :value $moduleindex
     :text     CARD    :label "Current CARD:" :deaf T :w 8 :bold T :value $card
     :next-row T
     :number SRAMWAIT  :w 2 :label "Nb Waitstates" :min 0 :max 6 :value $wait :valuex 12c
      :next-row T
    :button SRAMDATA  :label DATA :w 12
     :button SRAMADDRESS  :label "ADDRESS" :w 12 
     :next-row T
     :button SRAMTIME  :label TIMING :w 12
     :button SRAMRESET  :label RESET :w 12
     :next-row T
     :galley SRAMRESULTS :rows 16 :cols 40 :deaf T
     :next-row T
     :button INFO	:label "Info"   :w 4 
     :button SRAMFINISH :label "Quit"   :w 4

   :show T

write-vxi-register $CurrentVXIModule.GIR.DSP.Wait $wait

 ###################################
proc click-sramwait {v} {
   global CurrentVXIModule wait
write-vxi-register $CurrentVXIModule.GIR.DSP.Wait $v
set wait $v
}


 ###################################
proc click-sramdata {args} {
   global CurrentVXIModule

    write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0x4
after 500

   :modify SRAMRESULTS :append F
#start TEST DATA
    write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0x2
after 1000
ReadEvent
				}


 ###################################
proc click-sramaddress {args} {
   global CurrentVXIModule


    write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0x4
after 500

   :modify SRAMRESULTS :append F
#test address
    write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0x1

after 1000
ReadEvent
}

 ###################################
proc click-sramtime {args} {
   global CurrentVXIModule

#reset
    write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0x4

#test time
    write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0x8
}

 ###################################
proc click-sramreset {args} {
   global CurrentVXIModule

#reset
    write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0x4

}
###################################
proc click-info args {
    global TclBase
   midas-show-file  "$TclBase/info/sramtest.txt"
}


###################################
proc click-sramfinish args {
   global CurrentVXIModule

    click-quit [self frame-name].sram
}

###################################
proc ReadEvent {} {
   global CurrentVXIModule moduleindex card

   :modify MODULE :value $moduleindex
   :modify CARD :value $card


set baseevent [expr (0x26003*4)]
set length 16
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $baseevent -l $length"	
     	set DataRAM [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
       foreach word $DataRAM {
:modify SRAMRESULTS :strings "[format "0x%x" $word]\n"}
}

