#    hist task code overlay for detector type "ess"


set lowchannel  0
set highchannel 9
set maxchannel  9
set qualifier  1

set essnames    {TDC.QA TDC.QB TDC.QC TDC.QD TDC Pattern Energy}
set girnames    {GIR.EvNum}

set qnames    {q0 q1 q2 q3}
set qualnames {0 1 2 3}

set ess 0
set gir 0


proc make-overlaypanel {} {
   global essnames qnames girnames

      :layout H; :row-gap 10; :col-gap 20

      :message DET-M1   :label "ESS overlay applied"
      :next-row T

      :number DET-LOW  :label "Low channel:"  :w 5 :valuex 12c
      :next-row T
      :number DET-HIGH :label "High channel:" :w 5 :valuex 12c
      :next-row T
      :choice DET-QUAL  :label "Qualifier"  :valuex 10c  :exclusive F :strings $qnames :value 1
      :vskip -80
      :choice DET-ESS   :label "Items"   :exclusive F :strings $essnames  :value 0 :layout V :w 10
      :next-row T
      :vskip -40
      :choice DET-GIR   :label "GIR"        :valuex 10c  :exclusive F :strings $girnames :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-ESS      {click-adc $v ess}
      DET-GIR       {click-adc $v gir}
      default       {}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global ess gir qualifier

   if {[llength $spectrumlist] > 0} then {
       :modify DET-ESS   :value 0
       :modify DET-GIR :value 0
       :modify DET-QUAL :value 0
   } else {
       :modify DET-ESS   :value $ess
       :modify DET-GIR :value $gir
       :modify DET-QUAL :value $qualifier
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global essnames ess girnames gir qualnames qualifier
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set qlist   [list-take $qualnames [bits-in $qualifier]]

        set list {}
# append  spectrum names
        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
            foreach adc [list-take $essnames [bits-in $ess]]  {
                 foreach q $qlist {lappend list ESS$i.$adc.q$q}
            }
# append GIR
            foreach adc [list-take $girnames [bits-in $gir]] {
                 foreach q $qlist {lappend list ESS$i.$adc.q$q}
            }

        }
        return $list
}

proc range-of n {

    set fields [split $n "."]
    if {[string match "ESS*" [first $fields]]} then {
        switch -glob [second $fields]  {
            GIR      {return 0x10000}
            Pattern  {return 4096}
            Energy   {return 4096}
            default  {return 2048}
        }
    }
}
