#    hist task code overlay for detector type "fvi"


set lowchannel  0
set highchannel 1
set maxchannel  1

set qualifier 1

set qnames   {q0 q1 q2 q3}
set qualnames {0 1 2 3}

set fvinames   {}
set girnames   {GIR.EvNum}

set gir 0


proc make-overlaypanel {} {
   global girnames qnames

    :layout V; :row-gap 10; :col-gap 20

      :message DET-M1   :label "FVI overlay applied"

      :number DET-LOW  :label "Low module:"   :w 5 :valuex 15c
      :number DET-HIGH :label "High module:"  :w 5 :valuex 15c

      :choice DET-QUAL  :label "Qualifier" :valuex 10c :exclusive F :strings $qnames   :value 1
      :choice DET-GIR   :label "GIR"   :valuex 10c  :exclusive F :strings $girnames  :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-GIR            {click-adc $v gir}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global gir qualifier

   if {[llength $spectrumlist] > 0} then {
       :modify DET-GIR   :value 0
       :modify DET-QUAL  :value 0
   } else {
       :modify DET-GIR   :value $gir
       :modify DET-QUAL  :value $qualifier
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global girnames gir qualnames qualifier
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set qlist   [list-take $qualnames [bits-in $qualifier]]
        set list {}

        for {set i $lowchannel} {$i<=$highchannel} {incr i} {

# append  spectrum names
            foreach q $qlist {
               foreach adc [list-take $girnames  [bits-in $gir]]  {lappend list FVI$i.$adc.q$q}
            }
        }
        return $list
}

proc range-of n {return 0x10000}
