# hrge8x.tcl---HRGe8x card setup

#    April 18 1999  first version for testing prototype cards   VP

set debug 0
set started 0

set frame HRGe8x
set frametitle "HRGe8x Card Setup"
set icontitle HRGe8x

set chanlist {???}
set chanindex 0

set seglist {A B C D}
set segindex 0

set defaultchanlist {0 1 2 3 4 5 6 7}

set cardtype HRGe8x
set chantype ""
set VXIGlobal ""


global chansel chanlist chanindex

#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL) {channel widget->channel channel->widget nil
        nil nil nil nil nil nil nil 1 nil}
set table(ALLCHANS) {allchans int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ENABLE) {enable int-widget->param param->int-widget "Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Enable"}

set table(CCR2) {ccr2 int-widget->param param->int-widget "PreAmp_Input_Polarity"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 ""}
set table(CCR3) {ccr3 int-widget->param param->int-widget "DPPC.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 ""}
set table(CCR4) {ccr4 int-widget->param param->int-widget "Shaping_Amp_Range"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 ""}
set table(CCR5) {ccr5 int-widget->param param->int-widget "DPPC_Input_Mode"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 ""}
set table(CCR6) {ccr6 int-widget->param param->int-widget "TAC_Range"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 ""}

set table(ADDR6) {addr6 widget->param param->hex-widget "6MeV.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "6 MeV Address"}
set table(READOUTGEN) {readoutgen widget->param param->hex-widget "PARIL.RCR"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Paril RCR"}
set table(READOUT6) {readout6 int-widget->param param->int-widget "6MeV.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "6 MeV Readout"}
set table(ADDR20) {addr20 widget->param param->hex-widget "20MeV.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "20 MeV Address"}
set table(READOUT20) {readout20 int-widget->param param->int-widget "20MeV.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "20 MeV Readout"}
set table(ADDRT) {addrt widget->param param->hex-widget "TAC.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "TAC Address"}
set table(READOUTT) {readoutt int-widget->param param->int-widget "TAC.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TAC Readout"}
set table(POTMEMNEG) {potmemneg slider-widget->param param->int-widget "PotAdjust.6MeV_Neg"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 ""}
set table(POTMEMPOS) {potmempos slider-widget->param param->int-widget "PotAdjust.6MeV_Pos"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 ""}
set table(PDSGATE) {pdsgate slider-widget->param param->int-widget "PDSGate.Width"
       unit-reg->param param->unit-reg ns :slider 128 255 1 1 "PDS Gate Width"}
set table(POLEZERO) {polezero slider-widget->param param->int-widget "PoleZero.Thresh"
       int-reg->param param->int-reg nil :slider 0 255 1 1 "Pole Zero"}
set table(6MEVOFFSET) {6mevoffset slider-widget->param param->int-widget "6MeV.Offset"
       unit-reg->param param->unit-reg keV :slider 0 255 1 1 "6 MeV Offset"}
set table(20MEVOFFSET) {20mevoffset slider-widget->param param->int-widget "20MeV.Offset"
       unit-reg->param param->unit-reg keV :slider 0 255 1 1 "20 MeV Offset"}
set table(FTSAMPLE) {ftsample slider-widget->param param->int-widget "FTSample.Thresh"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "FT Sample Thres"}
set table(CFDDELAY) {cfddelay slider-widget->param param->int-widget "CFD.Delay"
       int-reg->param param->int-reg nil :slider 0 255 1 1 "CFD Delay"}
set table(CFDWIDTH) {cfdwidth slider-widget->param param->int-widget "CFD.Width"
       int-reg->param param->int-reg nil :slider 0 4095 1 1 "CFD Width"}
set table(VALSAMPLE) {valsample slider-widget->param param->int-widget "Valid_Thresh"
       unit-reg->param param->unit-reg ns :slider 0 4095 1 1 "Val Sample Threshold"}
set table(ADDBACK) {addback slider-widget->param param->int-widget "Addback_Thresh"
       unit-reg->param param->unit-reg ns :slider 0 4095 1 1 "Addback Window Threshold"}
set table(PILEUPTHRESH) {pileupthresh slider-widget->param param->int-widget "PileUp.Thresh"
       unit-reg->param param->unit-reg keV :slider 0 255 1 1 "PileUp Thresh"}
set table(CFDTHRESH) {cfdthresh slider-widget->param param->int-widget "CFD.Thresh"
       unit-reg->param param->unit-reg mV :slider 0 255 1 1 "CFD Thresh"}
set table(MODELCODE) {modcode str-widget->param param->hex-widget "VXI.ModelCode" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(SERIALNUM) {serialnum str-widget->param param->hex-widget "VXI.SerialNum" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MODLEVEL) {modlevel str-widget->param param->hex-widget "VXI.ModLevel" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MANID) {manid str-widget->param param->hex-widget "VXI.ManID" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(OFFSET) {offset str-widget->param param->hex-widget "VXI.Offset" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(LASTCARD) {lastcard int-widget->param param->int-widget "LastCard"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Last Card"}
set table(RESETFIFO) {resetfifo int-widget->param param->int-widget "FIFO.Reset"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Fifo Reset"}
set table(RESETDSP) {resetdsp int-widget->param param->int-widget "DSP.Reset"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "DSP Reset"}
set table(RESETGIR) {resetgir int-widget->param param->int-widget "ResetGIR"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "GIR Reset"}
set table(PILEUP) {pileup int-widget->param param->int-widget "PileupReject" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "Pileup Reject"}
set table(VETO) {veto int-widget->param param->int-widget "VetoReject" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "Veto Reject"}
set table(SYNGENE) {syngene int-widget->param param->int-widget "SynchroTestGenEnable" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "Synchro Test Gen Enable"}
set table(SINGRDTMODE) {singrdtmode int-widget->param param->int-widget "SinglesReadoutEnable" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "Singles Readout Enable"}
set table(STOPTAC) {stoptac int-widget->param param->int-widget "TACStopMode" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "TAC Stop Mode"}
set table(MULTIP) {multip int-widget->param param->int-widget "MultiplicityMode" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "Multiplicity Mode"}
set table(WRPROTPROM) {wpprotprom int-widget->param param->int-widget "EEPROMWriteEnable" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "EEPROM Write Enable"}
set table(ORMULT) {wpprotprom int-widget->param param->int-widget "OrMultiplicity" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "Or Multiplicity"}
set table(CCL) {ccl int-widget->param param->int-widget  "CCLCode" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CCL Code"}

#    GIR items

set table(GIRROCRVALACKTIMEOUTRESET) {girrocrvalacktimeoutreset logic-widget->param param->logic-widget "GIR.RCR.ValAck.TimeOutReset"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRREADOUTDISABLE)     {girreadoutdisable     logic-widget->param param->logic-widget "GIR.RCR.ReadOut.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREVNUMDATADISABLE) {girevnumdatadisable logic-widget->param param->logic-widget "GIR.RCR.EvNumData.Disable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREVNUMQBITSENABLE) {girevnumqbitsenable logic-widget->param param->logic-widget "GIR.RCR.EvNumQbits.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRPIPELINEENABLE) {girpipelineenable logic-widget->param param->logic-widget "GIR.RCR.PipeLine.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRCDTENABLE) {gircdtenable logic-widget->param param->logic-widget "GIR.RCR.CommonDeadTime.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCREXTENABLE) {girextenable logic-widget->param param->logic-widget "GIR.RCR.ExtReadout.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROCRPARILTEST) {girparilenable logic-widget->param param->logic-widget "GIR.RCR.TestParil.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}


set table(GIRDCRDSPENABLE) {girdcrdspenable logic-widget->param param->logic-widget "GIR.DCR.DSP_Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRSARDSPENABLE) {girdcrsardspenable logic-widget->param param->logic-widget "GIR.DCR.DataXfer1.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRDSPFIFOENABLE) {girdcrdspfifoenable logic-widget->param param->logic-widget "GIR.DCR.DataXfer2.Enable"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRDCRSPECTRE) {girdcrspectre logic-widget->param param->logic-widget "GIR.DCR.Spectre"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRDCRSCALER) {girdcrscaler logic-widget->param param->logic-widget "GIR.DCR.Scaler"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROTSR)    {girrotsr    int-widget->param param->hex-widget "GIR.ROTSR"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRFIFOSTATUS)    {girrotsrfifostatus    int-widget->param param->hex-widget "GIR.ROTSR.FIFO.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUSGIR)    {girrotsrtempstatusgir    int-widget->param param->TEMP-widget "GIR.ROTSR.Temp.Status.GIR"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUS1)    {girrotsrtempstatus1    int-widget->param param->ATEMP-widget "GIR.ROTSR.Temp.Status1"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(GIRROTSRTEMPSTATUS2)    {girrotsrtempstatus2    int-widget->param param->ATEMP-widget "GIR.ROTSR.Temp.Status2"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADTEMPHIGH)    {girtcrreadtemphigh    int-widget->param param->degree-widget "GIR.TCR.ReadTempHigh"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADTEMPLOW)    {girtcrreadtemplow    widget->param param->degree-widget "GIR.TCR.ReadTempLow"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRWRITETEMPHIGH)    {girtcrwritetemphigh    int-widget->param param->int-widget "GIR.TCR.WriteTempHigh"
                     degree-reg->param param->degree-reg 2 :text 4 nil nil 1 "Temp high"}

set table(GIRTCRWRITETEMPLOW)    {girtcrwritetemplow   int-widget->param param->int-widget "GIR.TCR.WriteTempLow"
                     degree-reg->param param->degree-reg 2 :text 4 nil nil 1 "Temp low"}

set table(GIRTCRREADTEMP)    {girtcrreadtemp    int-widget->param param->degree-widget "GIR.TCR.ReadTemp"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADALARMLOW) {girtcrreadalarmlow  logic-widget->param param->logic-widget "GIR.TCR.ReadConfig.Low"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRTCRREADALARMHIGH) {girtcrreadalarmhigh  logic-widget->param param->logic-widget "GIR.TCR.ReadConfig.High"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRROTSRVALACKTIMEOUTSTATUS) {girrotsrvalacktimeoutstatus  logic-widget->param param->logic-widget "GIR.ROTSR.ValAck.TimeOut.Status"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(GIRVALACKTIMEOUT)    {girvalacktimeout    slider-widget->param param->int-widget "GIR.ValAck.TimeOut"
                     unit-reg->param param->unit-reg ns nil nil nil nil 0 nil}

proc degree-reg->param {p v} {global $p; set $p [scan-int $v]}
proc param->degree-reg {p v u} {return "[expr $v*$u]"}
proc param->degree-widget {p v u} {return "$p :value [expr $v/2]"}

proc param->TEMP-widget {p v u} {
#    insert-debug "param->TEMP-widget $p $v $u"
    switch $v {
       1  {set s higher}
       2  {set s lower}
       0  {set s ok}
       default {set s ??}
    }
    return "$p :value $s"
}

proc param->ATEMP-widget {p v u} {
#    insert-debug "param->TEMP-widget $p $v $u"
    switch $v {
       2  {set s higher}
       1  {set s lower}
       3  {set s ok}
       default {set s ??}
    }
    return "$p :value $s"
}

#    register selection for parameter save function

#   note -   MCR_analog is the Ge Inner Control Register at  address 0x12
set registersavepatterns {
   [A-D].CCR
   [A-D].CFD.Thresh [A-D].CFD.Delay [A-D].FTSample.Thresh [A-D].PoleZero.Thresh
   [A-D].PileUp.Thresh [A-D].PDSGate.Width
   [A-D].20MeV.Offset [A-D].20MeV.ROEnable
   [A-D].6MeV.Offset  [A-D].6MeV.ROEnable
   [A-D].TAC.ROEnable
   [A-D].PotAdjust.6MeV_Neg [A-D].PotAdjust.6MeV_Pos
   Valid_Thresh Addback_Thresh
   GIR.RCR  GIR.DCR GIR.ValAck.TimeOut
   PileupReject CFD.Width
   MCR_analog
   [A-D].PARIL.RCS
}

# inspection tables must be in same order as entries in the :choice-stacks
# this is achieved by using these tables when generating the choices
# index number returned maps directly to the signal number to be written to 
# the Signal Select register

set insp_table(MUX-AI1) {"Insp.A1" AI}
set insp_table(MUX-AI2) {"Insp.A2" AI}
set insp_table(MUX-DI1) {"Insp.D1" DI}
set insp_table(MUX-DI2) {"Insp.D2" DI}
set insp_table(MUX-VI)  {"Insp.V"  VI}

set insp_menu(MUX-AI1) analogueinsptable
set insp_menu(MUX-AI2) analogueinsptable
set insp_menu(MUX-DI1) digitalinsptable
set insp_menu(MUX-DI2) digitalinsptable
set insp_menu(MUX-VI)  voltageinsptable


set inspection_widgetnames {MUX-AI1 MUX-AI2 MUX-DI1 MUX-DI2 MUX-VI}
set inspection_regnames    {Insp.A1 Insp.A2 Insp.D1 Insp.D2 Insp.V}

#    the inspection line tables are in parallel
#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

set analogueinsptable {Disconnected
      PreAmp-In 6MeV-Out 20MeV-Out PZ_BLR 6MeV-PDS TAC-Out CFD-In DPPC-In
}

set AI-ChanSelect {0 * * * * * * * *}
set AI-Param      {* 0 1 2 3 4 5 6 7}

set voltageinsptable {Disconnected
     Vtemp_Lower Vtemp_Upper Vp_20 Vp_15 Vm_15 Vp_12 Vm_12 Vcc_5 Vcc_5_Analog Vp_4 Vm_3 Vm_2 Vee Vref_5 Vpref_3 Vmref_3
}
set VI-ChanSelect {0 1 1 1 1 1 1 1 1 1 1 1  1  1  1  1  1}
set VI-Param      {* 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}


set digitalinsptable {Disconnected
        CFD-Direct CFD-Delay Start-LT FT-Sample Val-Sample PDS-Gate TAC-Reset prepileup-in/LT-Reset
        Fast_Trigger Inhibit_Action Validation Event_Reject Beam_Pulse
        OrValack DeadTime StartReadout ReninCorr DTready0 DTready1 DTready2 DTready3 DTack_buf RenoutCorr Clkwf Enwf
        StartReadoutSingles ReninSingles Latch_Singles_Event RenoutSingles
        AS*(VME) DS(VME) R/W*(VME) ModRoco CardRenin* BLTACK(Card) BLTACK(Bus) FDTACK DTACK*(VME) Oe_EVRI CardRenout LT_Reset* Clk-Fifo Enr-F1 OrFifo ResetFifo Sysclk
        Start_DMA DMA-Req DMA-Grant Link_Start Link5_Ack Link5_Clk Link5_Dat0  Link5_Dat1 Link5_Dat2 Link5_Dat3 OE_Link5_out OE_DSP_Run 
        Rdt-Evt-Fault-M1 Rdt-Evt-Fault Rdt-Evt-Match ParilLi1 ParilLi2
}



set DI-ChanSelect {0 * * * * * * * *
        32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32
        32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32 32 32
        32 32 32 32 32
}

set DI-Param      {* 0 1 2 3 4 5 6 7
        1 2 3 4 5
        6 7 8 9 10 11 12 13 14 15 16 17
        18 19 20 21
        22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38
        39 40 41 42 43 44 45 46 47 48 49 50
        51 52 53 54 55
}

set digitalinspmenu1 {Disconnected
        CFD-Direct CFD-Delay Start-LT FT-Sample Val-Sample PDS-Gate TAC-Reset prepileup-in
        {"Trigger Signals"
        Fast_Trigger Inhibit_Action Validation Event_Reject Beam_Pulse
        }
        {"Corrolated Readout PARIL to EVRI"
        OrValack DeadTime StartReadout ReninCorr DTready0 DTready1 DTready2 DTready3 DTack_buf RenoutCorr Clkwf Enwf
        }
        {"Singles Readout PARIL to EVRI"
        StartReadoutSingles ReninSingles Latch_Singles_Event RenoutSingles
        }
        {"Corrolated VXI Readout"
        AS*(VME) DS(VME) R/W*(VME) ModRoco CardRenin* BLTACK(Card) BLTACK(Bus) FDTACK DTACK*(VME) Oe_EVRI CardRenout LT_Reset* Clk-Fifo Enr-F1 OrFifo ResetFifo Sysclk
        }
        {"DSP Interface"
        Start_DMA DMA-Req DMA-Grant Link_Start Link5_Ack Link5_Clk Link5_Dat0  Link5_Dat1 Link5_Dat2 Link5_Dat3 OE_Link5_out OE_DSP_Run
        }
        Rdt-Evt-Fault-M1 Rdt-Evt-Fault Rdt-Evt-Match ParilLi1 ParilLi2

}
set digitalinspmenu2 {Disconnected
        CFD-Direct CFD-Delay Start-LT FT-Sample Val-Sample PDS-Gate TAC-Reset LT-Reset
        {"Trigger Signals"
        Fast_Trigger Inhibit_Action Validation Event_Reject Beam_Pulse
        }
        {"Corrolated Readout PARIL to EVRI"
        OrValack DeadTime StartReadout ReninCorr DTready0 DTready1 DTready2 DTready3 DTack_buf RenoutCorr Clkwf Enwf
        }
        {"Singles Readout PARIL to EVRI"
        StartReadoutSingles ReninSingles Latch_Singles_Event RenoutSingles
        }
        {"Corrolated VXI Readout"
        AS*(VME) DS(VME) R/W*(VME) ModRoco CardRenin* BLTACK(Card) BLTACK(Bus) FDTACK DTACK*(VME) Oe_EVRI CardRenout LT_Reset* Clk-Fifo Enr-F1 OrFifo ResetFifo Sysclk
        }
        {"DSP Interface"
        Start_DMA DMA-Req DMA-Grant Link_Start Link5_Ack Link5_Clk Link5_Dat0  Link5_Dat1 Link5_Dat2 Link5_Dat3 OE_Link5_out OE_DSP_Run
        }
        Rdt-Evt-Fault-M1 Rdt-Evt-Fault Rdt-Evt-Match ParilLi1 ParilLi2

}


loadsource dppc
loadsource paril

loadsource common.vxi



proc click-girtcrclralarm {} {
    global cardtype chanlist chanindex
    write-vxi-register $cardtype[lindex $chanlist $chanindex].GIR.TCR.ClearAlarm 0
    after 1000
    click-redisplay
}


proc click arg {
   global debug userselection allchans
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      *REDISPLAY   {click-redisplay}
      ENGINEERING  {click-$v}

      PARIL        {start-PARIL}
      DPPC         {start-DPPC}
      EXPERT       {start-EXPERT}

      CHANNEL     {click-channel $v}
      SEGMENT     {click-segment $v}
      ALLCHANS    {click-whichchans $v}
      ALLSEGS     {click-whichsegs $v}

      CHANSEL   {click-chanselection $v}
      SEGSEL    {click-segselection $v}

      PARAM       {click-param $v}
      MUX-*       {click-inspection $w $i}

      POTMEMNEG   {click-on POTMEMPOS 0; click-on POTMEMNEG $v}
      POTMEMPOS   {click-on POTMEMNEG 0; click-on POTMEMPOS $v}

      default   {
          if {$allchans < 0} then {set userselection 1}
             click-on $w $v
             set userselection 0
      }
   }
}


set electronicsframe [self frame-name].electronics
set electronicsvisible 0

set expertframe [self frame-name].expert
set expertvisible 0

set girframe [self frame-name].gir
set girvisible 0


proc start-EXPERT {} {
   global expertvisible expertframe
   if {$expertvisible==0} then {make-expert} else {open-frame $expertframe}
   click-redisplay
}

proc click-GIR {w c i} {
   global cardtype 
   switch $c {
      "GIR Status"      {start-GIR}
      "GIR Control"     {inform gir "start_with_card $cardtype"}
   }
}

proc start-GIR {} {
#  display GIR sub frame
   global girvisible girframe
   if {$girvisible==0} then {make-GIR} else {open-frame $girframe}
   click-redisplay
} 
   
#####################
proc make-frame1 {} {
  global env chanlist seglist
  global analogueinsptable digitalinsptable voltageinsptable digitalinspmenu1 digitalinspmenu2

  :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

   :panel P1 :layout T :padx 10 :pady 5
     :layout H; :row-gap 10; :col-gap 10
      :choice-stack CHANNEL :label "Current Detector:" :strings $chanlist :valuex 16c
      :choice-stack SEGMENT :label "Current Crystal:"  :strings $seglist :valuex 16c
      :checkbox ENABLE :label "Enable:" :valuex 8c
      :next-row T
      :choice ALLCHANS :label "Act on Detectors?" :valuex 16c :strings [list Current All Select] :value 0
      :choice ALLSEGS  :label "Act on Crystals?"  :valuex 16c :strings [list Current All Select] :value 0

   :panel P2 :layout T :padx 10
     :layout H; :col-gap 20;  :row-gap 5
      :message M1 :label "Readout Enable" :bold T
      :checkbox READOUT6   :label "6 MeV"   :valuex 10c
      :checkbox READOUT20  :label "20 MeV"
      :checkbox READOUTT   :label "TAC"

   :panel P3 :layout T :padx 10 :pady 10
     :layout V; :row-gap 5
      :slider PDSGATE      :label "PDS Gate Width (ns):"       :min 0 :max 10000   :valuex 30c
      :slider POLEZERO     :label "Pole Zero Threshold:"       :min 0 :max 255   :valuex 30c
      :slider FTSAMPLE     :label "Fast Trigger Sample (ns):"  :min 0 :max 3000   :valuex 30c
      :slider CFDDELAY     :label "CFD Output Delay:"          :min 0 :max 255   :valuex 30c
      :slider PILEUPTHRESH :label "PileUp Threshold (keV):"    :min 0 :max 58112   :valuex 30c
      :slider CFDTHRESH    :label "CFD Threshold (mV):"        :min 0 :max 255   :valuex 30c

      :vskip 10
      :slider CFDWIDTH     :label "CFD Width:"                 :min 0 :max 4095 :steps 4096  :valuex 30c
      :slider VALSAMPLE    :label "Validation Sample (ns):"    :min 0 :max 10000 :steps 4096  :valuex 30c

   :panel P4 :layout T :padx 10 :pady 10
      :layout H; :col-gap 10; :row-gap 10
      :menubutton MUX-AI1 :label "Analogue Inspection 1:" :w 22 :menu $analogueinsptable
      :message MUX-AI1-USE   :label ""
      :next-row T
      :menubutton MUX-AI2 :label "Analogue Inspection 2:" :w 22 :menu $analogueinsptable
      :message MUX-AI2-USE   :label ""
      :next-row T
      :menubutton MUX-DI1 :label "Digital Inspection 1:"  :w 22 :menu $digitalinspmenu1 
      :message MUX-DI1-USE   :label ""
      :next-row T
      :menubutton MUX-DI2 :label "Digital Inspection 2:"  :w 22 :menu $digitalinspmenu2 
      :message MUX-DI2-USE   :label ""
      :next-row T
      :menubutton MUX-VI  :label "Voltage Inspection:"    :w 22 :strings $voltageinsptable :rows 10
      :message MUX-VI-USE   :label ""

   :panel P5 :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 10; :row-gap 5
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :menubutton GIR  :label "EVRI/GIR"  :strings [list "GIR Status" "GIR Control"]  :command click-GIR
     :next-row T
      :button REDISPLAY
      :button EXPERT   :label "Expert Setup"
      :button PARIL    :label "PARIL"
      :button DPPC     :label "DPPC"
      :button HELP  
   
 :show T
}

proc make-electronics {} {
  global env electronicsframe electronicsvisible

  :frame "$electronicsframe" :label "HRGe8x Electronics" :resize F :transient T

   :panel P20 :layout T :padx 5 :pady 5
      :layout H; :row-gap 5
      :message GMCR              :label "GIR Control Register:" :bold T  :valuex 20c 
      :message VXIREGISTER       :label "VXI Registers:"  :bold T        :valuex 20c
    :next-row T
      :checkbox LASTCARD  :label "Last Card:"                            :valuex 20c
      :text MODELCODE     :label "Model Code:" :w 6  :read-only T        :valuex 20c
    :next-row T
      :checkbox RESETFIFO      :label "Reset Fifo:"                      :valuex 20c
      :text SERIALNUM     :label "Serial Number:" :w 6 :read-only T      :valuex 20c
    :next-row T
      :checkbox RESETDSP      :label "Reset DSP:"                        :valuex 20c
      :text MODLEVEL      :label "Modification Level:" :w 6 :read-only T :valuex 20c
    :next-row T
      :checkbox RESETGIR      :label "Reset GIR:"                        :valuex 20c
      :text MANID         :label "Manufacturer ID:" :w 6  :read-only T   :valuex 20c

  :show T
 set electronicsvisible 1
}


proc make-expert {} {
  global env expertframe expertvisible

  :frame "$expertframe" :label "HRGe8x Card Setup (expert)" :resize F :transient T

   :panel P21 :layout T :padx 5 :pady 5
      :layout V; :row-gap 5
      :message GICR       :label "GE INNER Control Register:" :bold T       :valuex 30c 
      :choice PILEUP      :label "PileUp"              :strings [list Mark Reject] :value 0   :valuex 20c 
      :choice VETO        :label "Veto"                :strings [list Mark Reject] :value 0   :valuex 20c 
      :choice SINGRDTMODE :label "Singles Event"       :strings [list Disable Enable] :value 0   :valuex 20c 
      :choice STOPTAC     :label "Stop TAC With"       :strings [list FT Beam] :value 0   :valuex 20c 
      :choice MULTIP      :label "Multiplicity"        :strings [list Raw Clean] :value 0   :valuex 20c 
      :choice WRPROTPROM  :label "Write Protect Prom"  :strings [list Off On] :value 0   :valuex 20c 
      :choice ORMULT      :label "Mult Mode "          :strings [list  Channel Clover] :value 0   :valuex 20c 
      :choice CCL         :label "CCL Mode"            :strings [list Default AddBack Mode2 Mode3 Mode4] :value 0   :valuex 20c 

      :vskip 20
      :message CCR  :label "Channel Control Register" :bold T  :valuex 30c
      :choice CCR2  :label "PA Input Polarity" :strings [list Negative Positive]  :valuex 20c :w 12
      :choice CCR3  :label "DPPC"              :strings [list Disable Enable]  :valuex 20c :w 12
      :choice CCR4  :label "Shaping Amp Range" :strings [list 20MeV 3MeV]  :valuex 20c :w 12
      :choice CCR5  :label "DPPC Input"        :strings [list Charge Current]  :valuex 20c :w 12
      :choice CCR6  :label "TAC Range"         :strings [list 0=>200ns 0=>2us]  :valuex 20c :w 12

      :vskip 20
      :message DACADJ  :label "Channel DAC Adjustment" :bold T  :valuex 30c
      :slider 6MEVOFFSET   :label "6 MeV Offset (keV):"        :min 0 :max 6912   :valuex 20c
      :slider 20MEVOFFSET  :label "20 MeV Offset (keV):"       :min 0 :max 6912   :valuex 20c

      :vskip 20
      :message POTMEMMAP  :label "Gain Match Setup" :bold T  :valuex 30c
      :slider POTMEMNEG    :label "6 MeV (-ve adj)"  :min 0 :max 255    :valuex 20c
      :slider POTMEMPOS    :label "6 MeV (+ve adj)"  :min 0 :max 255    :valuex 20c

      :vskip 20
      :slider ADDBACK      :label "Addback Window (ns):"       :min 0 :max 900 :steps 4096  :valuex 20c
   
  :show T
 set expertvisible 1
}


proc make-GIR {} {
  global env girvisible girframe

set col1 40c

  :frame "$girframe" :label "HRGe8x E.V.R.I/GIR Status" :show-footer T :resize F :transient T 

  :panel PANEL1 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5

      :message M1 :label "DSP Control Register" :bold T
      :next-row T
      :checkbox GIRDCRDSPENABLE  :label "Data Xfer DSP=>Singles Enable" :valuex 30c
      :checkbox GIRDCRSPECTRE    :label "Enable Spectra" :valuex 15c
      :next-row T
      :checkbox GIRDCRSARDSPENABLE   :label "Data Xfer PARIL=>DSP Enable" :valuex 30c
      :checkbox GIRDCRSCALER         :label "Enable Scaler"       :valuex 15c
      :next-row T
      :checkbox GIRDCRDSPFIFOENABLE  :label "Data Xfer DSP=>VXI Enable" :valuex 30c

  :panel PANEL2 :layout T :padx 5 :pady 5
    :layout V; :row-gap 5; :col-gap 5
      :message M2 :label "E.V.R.I Readout Control Register" :bold T
      :checkbox GIRROCRVALACKTIMEOUTRESET :label "Enable Valack Timeout Reset"           :valuex $col1
      :checkbox GIRROCRREADOUTDISABLE     :label "EVRI Readout Disable:"                 :valuex $col1
      :checkbox GIRROCREVNUMDATADISABLE   :label "Event Number Readout Disable:"         :valuex $col1
      :checkbox GIRROCREVNUMQBITSENABLE   :label "Use Event Number Qbits:"               :valuex $col1
      :checkbox GIRROCRPIPELINEENABLE     :label "Pipeline readout enable:"              :valuex $col1
      :checkbox GIRROCRCDTENABLE          :label "CDT readout enable:"                   :valuex $col1
      :checkbox GIRROCREXTENABLE          :label "Ext readout enable:"                   :valuex $col1
      :checkbox GIRROCRPARILTEST          :label "Test Mode for PARIL readout:"          :valuex $col1

  :panel PANEL3 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5
      :message M3 :label "E.V.R.I Readout Status Register"  :bold T
      :next-row T
      :hskip 10
      :text    GIRROTSR            :label "Value"  :w 6
      :hskip 20
      :text    GIRROTSRFIFOSTATUS  :label "Fifo Status:" :w 6
      :next-row T
      :hskip 10
      :message M4 :label "Valack Timeout:" :bold T 
      :next-row T
      :checkbox GIRROTSRVALACKTIMEOUTSTATUS     :label "Asserted:" :deaf T
      :slider  GIRVALACKTIMEOUT          :label "(ns):"  :min 0 :max 2000000 :resolution 62

      :next-row T
      :vskip 10
      :message M5 :label "Temperature Register"  :bold T
      :next-row T
      :hskip 10
      :message M6 :label "Analog"  :bold T
      :text    GIRROTSRTEMPSTATUS1    :label "Sensor 1:"   :valuex 10c :w 6
      :text    GIRROTSRTEMPSTATUS2    :label "Sensor 2:"   :valuex 10c :w 6

      :next-row T
      :hskip 10
      :message M7 :label "GIR"  :bold T
      :next-row T
      :message M8  :label "Thresh : " 
      :message M9  :label "Read : " 
      :message M10 :label "Write : " 
      :message M11 :label "Alarm : " 
      :message M12 :label "Clear : " 

      :col-gap 15
      :next-row T
       :text    GIRTCRREADTEMPHIGH      :label "High (C): " :read-only T :w 6
      :text     GIRTCRWRITETEMPHIGH     :label "" :w 6
      :checkbox GIRTCRREADALARMHIGH     :label "" :deaf T :colours [list green red]
      :button   GIRTCRCLRALARM          :label "Clear"  :command click-girtcrclralarm
      :next-row T
      :text    GIRTCRREADTEMPLOW     :label "Low (C):  " :read-only T :w 6
      :text    GIRTCRWRITETEMPLOW     :label "" :w 6
      :checkbox GIRTCRREADALARMLOW     :label "" :deaf T :colours [list green blue]
      :next-row T
      :text    GIRTCRREADTEMP     :label "Temp (C):" :read-only T :w 6
      :text    GIRROTSRTEMPSTATUSGIR :label "" :read-only T :w 6
      :col-gap 30
      :button GIRREDISPLAY  :label Redisplay

  :show T
  set girvisible 1
}

proc make-chanSELframe {} {
  global chansel chanlist

   :frame CHANSEL-FRAME :label "HRGe8x Detector Selection"  :show-footer F :resize F :transient T
   :panel CHANSEL-PANEL :layout T
   :choice CHANSEL :exclusive F :strings $chanlist :value $chansel
   :show T
}  

proc make-segSELframe {} {
  global segsel seglist

   :frame SEGSEL-FRAME :label "HRGe8x Crystal Selection"  :show-footer F :resize F :transient T
   :panel SEGSEL-PANEL :layout T
   :choice SEGSEL :exclusive F :strings $seglist :value $segsel
   :show T
}  



proc define-vxi-register {mname class rname attributes} {
   global CurrentVXIServer VXIregister
   global EGallow
   set VXIregister /$CurrentVXIServer/$mname.$rname
#   insert-debug "define-vxi-register $VXIregister $class $attributes"
#     until we fix the VxWorks regsiter server to made delete work fully
#     ignore an already exists return to create
   set egallow $EGallow
   set EGallow 0x20006
   EG "register :name '$VXIregister' :class '$class' !new"
   set EGallow $egallow
   EG "register :name '$VXIregister' :object '$attributes'"
}

proc hrge8x_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc make_additional {slot} {
   global cardtype chanlist chanindex
   global registerbase

   for {set s 0} {$s <= 7} {incr s} {
      set registerbase $cardtype[lindex $chanlist $chanindex].$s
      for {set i 0} {$i <= 15} {incr i} {
         hrge8x_register   PARIL.DPPC_DataMem.i$i  xDig  "-s$slot -c$s -a0x1200 -z0x1000 -o[expr $i*4] -w32 -prw -fx"
      }
   }

}
