

#   icare.defn.tcl     Icare VXI card


proc {AddIcareModule}  {module slot}  {
   global registerbase cardtype nsockets

   set registerbase $cardtype#$module

   delete-vxi-registers $registerbase.*

   IcareVXIRegisters $slot
   IcareModuleRegisters $slot

   for {set socket 1} {$socket <= $nsockets} {incr socket} {

        set registerbase $cardtype[expr $module * $nsockets + $socket - 1]

        delete-vxi-registers $registerbase.*

#    first a register to record module each channel is in
        icare_register  ModuleName    generic "-n$cardtype#$module -tstring -pro"

        IcareVXIRegisters $slot
        IcareModuleRegisters $slot

        AddIcareDetector $slot $socket
   }
}

proc AddIcareDetector {slot socket} {

  IcareDetectorRegisters  $slot $socket
}

proc icare_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc IcareVXIRegisters {slot} {
   icare_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   icare_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   icare_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   icare_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   icare_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   icare_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   icare_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   icare_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   icare_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   icare_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   icare_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   icare_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   icare_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
}

proc IcareModuleRegisters {slot} {

	icare_register   FTMode            xDig "-s$slot -o0x1022 -w16 -prw -fd -b4 -l1 -i0"
	icare_register   ValMode           xDig "-s$slot -o0x1024 -w16 -prw -fd -b4 -l1 -i0"
	icare_register   SumBus            xDig "-s$slot -o0x1020 -w16 -prw -fd -b4 -l1 -i0"

	icare_register   Scalers.Load      xDig "-s$slot -a0x00000000 -o0x2c -w16 -pwo"
	icare_register   Scalers.Clear     xDig "-s$slot -a0x00000000 -o0x28 -w16 -pwo"

	icare_register   FIFO.Test_Reg     xDig "-s$slot -a0x00000000 -o0x3c -w32 -prw -fx"

	icare_register   Status            xDig "-s$slot -a0x00000000 -o0x38 -w16 -prw -fx"
	icare_register   FIFO.NotEmpty     xDig "-s$slot -a0x00000000 -o0x38 -w16 -pro -fd -b15 -l1"
	icare_register   LastCard          xDig "-s$slot -a0x00000000 -o0x38 -w16 -prw -fd -b0 -l1"
	icare_register   TimeoutTest       xDig "-s$slot -a0x00000000 -o0x38 -w16 -prw -fd -b2 -l1"
	icare_register   FIFOTest          xDig "-s$slot -a0x00000000 -o0x38 -w16 -prw -fd -b1 -l1"
	icare_register   Timeout256        xDig "-s$slot -a0x00000000 -o0x38 -w16 -pro -fd -b3 -l4"
	icare_register   TimeoutW3         xDig "-s$slot -a0x00000000 -o0x38 -w16 -pro -fd -b8 -l4"

        icare_register   FT.Width          xDAC "-s$slot -a0x00000000 -o0x02 -w16 -pwo -qn -us  -d0 -r0:0s,0xff:1275ns   -i250ns"
        icare_register   FT.Delay          xDAC "-s$slot -a0x00000000 -o0x04 -w16 -pwo -qn -us  -d0 -r0:0s,0xff:1275ns   -i50ns"
	icare_register   ValSample         xDAC "-s$slot -a0x00000000 -o0x06 -w16 -pwo -qn -us  -d0 -r0:0s,0xff:4080ns   -i800ns"
	icare_register   Watchdog          xDAC "-s$slot -a0x00000000 -o0x08 -w16 -pwo -qn -us  -d0 -r0:0s,0xff:20400ns  -i20.0us"

	icare_register   Insp.A1.Channel           xMux "-s$slot -o0x1000 -w16 -prw -b5 -l3 -dIcare -ma1"
	icare_register   Insp.A1.Signal            xDig "-s$slot -o0x1000 -w16 -prw -fd -b0 -l3 -i0"

	icare_register   Insp.A2.Channel           xMux "-s$slot -o0x1002 -w16 -prw -b5 -l3 -dIcare -ma2"
	icare_register   Insp.A2.Signal            xDig "-s$slot -o0x1002 -w16 -prw -fd -b0 -l3 -i0"

	icare_register   Insp.D1.Channel           xMux "-s$slot -o0x1004 -w16 -prw -b5 -l3 -dIcare -md1"
	icare_register   Insp.D1.Signal            xDig "-s$slot -o0x1004 -w16 -prw -fd -b0 -l3 -i0"

	icare_register   Insp.D2.Channel           xMux "-s$slot -o0x1006 -w16 -prw -b5 -l3 -dIcare -md2"
	icare_register   Insp.D2.Signal            xDig "-s$slot -o0x1006 -w16 -prw -fd -b0 -l3 -i0"

	icare_register   Insp.V.Channel            xMux "-s$slot -o0x1008 -w16 -prw -b5 -l4 -dIcare -mv"
	icare_register   Insp.V.Signal             xDig "-s$slot -o0x1008 -w16 -prw -fd -b0 -l4 -i0"

	icare_register   ASIC1.Pattern_Reg         xDig "-s$slot -a0x00000000 -o0x0d0 -O0x0a4 -w32 -prw -fx"
	icare_register   ASIC2.Pattern_Reg         xDig "-s$slot -a0x00000000 -o0x8d0 -O0x8a4 -w32 -prw -fx"

	icare_register   ASIC1.Correct_Reg         xDig "-s$slot -a0x00000000 -o0x0f8 -w32 -pwo -fx"
	icare_register   ASIC2.Correct_Reg         xDig "-s$slot -a0x00000000 -o0x8f8 -w32 -pwo -fx"

	icare_register   ASIC1.Format_Reg          xDig "-s$slot -a0x00000000 -o0x0f0 -w32 -pwo -fx"
	icare_register   ASIC2.Format_Reg          xDig "-s$slot -a0x00000000 -o0x8f0 -w32 -pwo -fx"

	icare_register   ASIC1.NormalRead          xDig "-s$slot -a0x00000000 -o0x08c -w32 -pro -fx"
	icare_register   ASIC2.NormalRead          xDig "-s$slot -a0x00000000 -o0x88c -w32 -pro -fx"

}

proc IcareDetectorRegisters {slot socket} {
    global registerbase

        set c [expr $socket - 1]

	icare_register  CFD.Delay         xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0x208 -w16 -pwo -qn -us -d0 -r0:0s,0xff:255ns -i5ns"
	icare_register  CFD.Thresh        xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0x206 -w16 -pwo -qm -uV -d0 -r0:0s,0xff:500mV -i30mV"
	icare_register  CFD.Width         xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0x20a -w16 -pwo -qn -us -d0 -r0:0s,0xff:255ns -i200ns"

	icare_register  FTSample          xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0x20c -w16 -pwo -qn -us  -d0 -r0:0s,0xff:1275ns   -i190ns"
	icare_register  ConvertDelay      xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0x20e -w16 -pwo -qn -us  -d0 -r0:0s,0xff:5100ns   -i3300ns"
	icare_register  LTWatchdog        xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0xe02 -w16 -pwo -qn -us  -d0 -r0:0s,0xff:20400ns  -i20.0us"

	icare_register  Shift.Go          xDig "-s$slot -c$c -z0x200 -o0x2200 -w16 -prw -fd -b3 -l1 "
	icare_register  Shift.Enable      xDig "-s$slot -c$c -z0x200 -o0x2202 -w16 -prw -fd -b4 -l1 "
	icare_register  Shift             xDig "-s$slot -c$c -z0x200 -o0x2204 -w16 -prw -fd -b0 -l3 "

	icare_register  Si2.Gain          xDig "-s$slot -c$c -z0x200 -o0x1212 -w16 -prw -fd -b1 -l1 "
	icare_register  CsI.Gain          xDig "-s$slot -c$c -z0x200 -o0x1214 -w16 -prw -fd -b2 -l1 "
	icare_register  Si1.Gain          xDig "-s$slot -c$c -z0x200 -o0x1216 -w16 -prw -fd -b3 -l1 "

	icare_register  CFD.Enable        xDig "-s$slot -c$c -z0x200 -o0x1210 -w16 -prw -fd -b0 -l1 "

	icare_register  Si2.PoleZero      xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0x200 -w16 -pwo -qm -uV -d0 -r0:0s,0xff:9180mV -i0mV"
	icare_register  CsI.PoleZero      xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0x202 -w16 -pwo -qm -uV -d0 -r0:0s,0xff:9180mV -i0mV"
	icare_register  Si1.PoleZero      xDAC "-s$slot -c$c -a0x00000000 -z0x200 -o0x204 -w16 -pwo -qm -uV -d0 -r0:0s,0xff:9180mV -i0mV"

	icare_register  Time.Addr         xAdr "-s$slot -c$c -a0x00000000 -z0x200 -o0x2c8 -O0x298 -prw -w32 -l16 -b0  -i$registerbase.Time"
	icare_register  Si2.Addr          xAdr "-s$slot -c$c -a0x00000000 -z0x200 -o0x2c8 -O0x298 -prw -w32 -l16 -b16 -i$registerbase.Si2"
	icare_register  CsI.Addr          xAdr "-s$slot -c$c -a0x00000000 -z0x200 -o0x3c8 -O0x398 -prw -w32 -l16 -b0  -i$registerbase.CsI"
	icare_register  Si1.Addr          xAdr "-s$slot -c$c -a0x00000000 -z0x200 -o0x3c8 -O0x398 -prw -w32 -l16 -b16 -i$registerbase.Si1"

	icare_register  Time.ROEnable     xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x74 -w32 -prw -fd -b16 -l1 -i1"
	icare_register  Si2.ROEnable      xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x74 -w32 -prw -fd -b17 -l1 -i1"
	icare_register  CsI.ROEnable      xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x74 -w32 -prw -fd -b18 -l1 -i1"
	icare_register  Si1.ROEnable      xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x74 -w32 -prw -fd -b19 -l1 -i1"

	icare_register  CFD.Scaler        xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x220 -w32 -pro -fd "
	icare_register  ADC.Scaler        xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x224 -w32 -pro -fd "

	icare_register  ASIC.Ident_Reg1    xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x2c8 -O0x298  -w32 -prw -fx"
	icare_register  ASIC.Ident_Reg2    xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x3c8 -O0x398  -w32 -prw -fx"

	icare_register  ASIC.Data_Reg1     xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x2d8 -O0x2b4  -w32 -prw -fx"
	icare_register  ASIC.Data_Reg2     xDig "-s$slot -c$c -a0x00000000 -z0x200 -o0x3d8 -O0x3b4  -w32 -prw -fx"

}


proc Icare_DAQ-reset   {args}   {
   set module [first $args]
#    no action
}


proc Icare_DAQ-halt   {args}   {
   set module [first $args]
#    no action
}


proc Icare_DAQ-go   {args}   {
   set module [first $args]
#    no action
}
