#    rdotst.tcl     generic VXI Version   /vxi/tcl/rdotst.tcl
#    added the collect system cards part

global EGreport
set debug 0
set started 0

set frame RDOTST
set frametitle "Readout Test"
set icontitle  "RDO Tst"
set testmodeset 0
set eventmemo 0
set eventrun 0
set scalercount 0
set scalerbase 0

# these lists are for the current make up of the system.
set cardtype ""
set Gechanlist {}
set Cloverchanlist {}
set ClusterGechanlist {}

set cardtypes {Ge Clover ClusterGe}
#			crate		type		channel		
set cardtable(0)	{					}
# then the number of cards in the system
set cardcount 0
# register infromation for each type of Ge card
set Gefifo 		"FIFO.test"

set Cloverfifo 		".Ge.RdOut.FIFOTest"

set ClusterGefifo 	".GIR.FIFO.Test"
# overhead is vre + trigger + module max: cluster = 8 x 4 !
set dataoverhead 46

# data patterns for the fifo push prior to each event
set fifocount 68
set fifopatterns { "0x55555555" "0xAAAAAAAA" "0x00000001" "0x00000002"
		   "0x00000004" "0x00000008" "0x00000010" "0x00000020"
		   "0x00000040" "0x00000080" "0x00000100" "0x00000200"
		   "0x00000400" "0x00000800" "0x00001000" "0x00002000"
		   "0x00004000" "0x00008000" "0x00010000" "0x00020000"
		   "0x00040000" "0x00080000" "0x00100000" "0x00200000"
		   "0x00400000" "0x00800000" "0x01000000" "0x02000000"
		   "0x04000000" "0x08000000" "0x10000000" "0x20000000"
		   "0x40000000" "0x80000000" "0x0FFFFFFE" "0x0FFFFFFD"
		   "0x0FFFFFFB" "0x0FFFFFF7" "0x0FFFFFEF" "0x0FFFFFDF"
		   "0x0FFFFFBF" "0x0FFFFF7F" "0x0FFFFEFF" "0x0FFFFDFF"
		   "0x0FFFFBFF" "0x0FFFF7FF" "0x0FFFEFFF" "0x0FFFDFFF"
		   "0X0FFFBFFF" "0x0FFF7FFF" "0x0FFEFFFF" "0x0FFDFFFF"
		   "0x0FFBFFFF" "0x0FF7FFFF" "0x0FEFFFFF" "0x0FDFFFFF"
		   "0x0FBFFFFF" "0x0F7FFFFF" "0x0EFFFFFF" "0x0DFFFFFF"
		   "0x0BFFFFFF" "0x07FFFFFF" "0xEFFFFFFF" "0xDFFFFFFF"
		   "0X8FFFFFFF" "0x4FFFFFFF" "0x0FFFFFFF" "0x00000000"}

# back to the copy information 

set tapestreams 1
set afterid ""
set triggerchanged 0

set vxireq 1
set ecreq 0
set datareq 0
set formatreq 0
set togglecount 0
set vxistatus 0
set vxistate 0
set ecstate 0
set datastate 0
set formatstate 0

set EGkeep 0
set EGkeep1 0

loadsource common.vxi

set eventcount 1

if {[info exists env(D2VBserver)]} then {set D2VBserver $env(D2VBserver)} \
    else {set D2VBserver nneb}

proc starttask {task} {
#    Check if it is necessary to pre-start server interface task

    set started [inform $task inquire started]
    if {$started == 0} then {
      send $task start
      send $task close-frame
    }
}



proc click-vxi {action} {

   starttask vxicontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-flush}
      3    {set p DAQ-reset}
    }

   set-footer "sending $p to VXI control task"
   set-busy
   set z [catch {send vxicontrol $p} m]
   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}
   redisplay-vxi
}

proc redisplay-vxi {} {
   global vxistatus vxistate

   set-busy
   starttask vxicontrol

   catch {set vxistatus [send vxicontrol read-vxistate]}
   :modify VXI :value $vxistatus
   :modify VXISTATE :value $vxistate

   clear-busy
}




proc redisplay-datareadout {} {
   global ecstate 


   :modify ECSTATE :deaf F :value $ecstate :deaf T

}
proc redisplay-format {} {
   global formatstate 


   :modify FORMATSTATE :deaf F :value $formatstate :deaf T

}

proc redisplay-datatransmit {} {
   global datastate 


   :modify DATASTATE :deaf F :value $datastate :deaf T

}

proc click-count {v} { 
   global eventcount
	set eventcount $v
}

proc click-event {v} {
   global eventcount togglecount afterid resource triggerchanged eventmemo eventrun testmodeset
   global vxistate datastate ecstate formatstate
	if {$v == 1 } {
		if { $eventrun == 0 } {
			foreach subsystem {VXI EC DATA FORMAT} {
	   			set [string tolower $subsystem]state 0
				click-redisplay
			}
			reset-d2vb-registers			
			set eventmemo $eventcount
			set eventrun 1
			set-footer "$eventmemo Readout Test events still to be sent"
			read-trigger-scalers
			make-event
		}
	}
	if {$v == 0 } { 
		set eventrun 0
		set triggerchanged 0
		set testmodeset 0
		after cancel $afterid 
		clear-footer
		click-redisplay
	}
}
proc sync-trig-noinhibit {} {
global triggerchanged resource
	EG "register :name '/$resource/TriggerMK2.VXI.Sync.Trig' :object '-n1' "
	set triggerchanged 1
}


proc sync-toggle {} {
	global debug afterid EGkeep togglecount EGreport eventrun
	set togglecount [expr {$togglecount -1 }]
	set EGkeep $EGreport
	set EGreport -1
	sync-trig 1
	sync-trig 0
	set EGreport $EGkeep
	if { $eventrun ==0 } {
		if {$togglecount == 0   } then  {
			clear-footer
			click-redisplay
		        } \
		else	{
			if {[expr { ($togglecount / 20 ) * 20 }] == $togglecount } {
				set-footer "Counting down $togglecount"
			}
			set afterid [ after 20 sync-toggle ]
		}
	}
}

proc sync-trig {v} {
	global resource
	EG "register :name '/$resource/TriggerMK2.VXI.Sync.Trig' :value '$v'"
}

proc click-redisplay {} {
  global vxireq ecreq datareq formatreq

  foreach subsystem {VXI EC DATA FORMAT} {
    set v [eval set [string tolower $subsystem]req]
       if {$v == 0} then {
         :modify [set subsystem]STATE :colours "white black" :value 0
       } else {
         :modify [set subsystem]STATE :colours "red green" :value 0
       }
  }

  if {$vxireq == 1} then {redisplay-vxi}
  if {$ecreq == 1} then {redisplay-datareadout}
  if {$datareq == 1} then {redisplay-datatransmit}
  if {$formatreq == 1} then {redisplay-format}
}

proc click-daq {action} {
  global vxireq ecreq datareq formatreq

   switch $action {
      0   {
#          insert-log "Data Acquisition Stopped [date]"
          set-footer "Stopping Data Acquisition [date]"
          if {$vxireq == 1} then {click-vxi 0}
          set-footer "Data Acquisition Stopped [date]"
         }
      1  {
          set-footer "Starting Data Acquisition [date]"
#    for GO perform checks on subsystem states
        if {$vxireq == 1} then {
#    check state of VXI system
          set state [inform vxicontrol VXI-ResetState]
          if {$state == 0} then {
             if {[midas-confirmation "One or more VXI crates have not been software reset"] == 0} \
                 then {clear-footer; return}
          }
          set state [inform vxicontrol VXI-RestoreState]
          if {$state == 0} then {
             if {[midas-confirmation "One or more VXI crates have not been software restored"] == 0} \
                 then {clear-footer; return}
          }
        }

          if {$vxireq == 1} then {click-vxi 2}
          if {$vxireq == 1} then {click-vxi 1}
          set-footer "Data Acquisition Started [date]"
#          insert-log "Data Acquisition Started [date]"
         }
   }
   click-redisplay
}

proc click arg {
	global debug
        global vxireq ecreq datareq formatreq

	if {$debug} then {puts stderr "click with argument \{$arg\}"}
	set f [lindex $arg 0]
	set c [lindex $arg 1]
	set w [lindex $arg 2]
	set v [lindex $arg 3]
	if {$c==":quit"} then {click-quit; return}
	switch -glob $w {
                VXI   {click-vxi $v}
                *REQ  {
                   eval set [string tolower $w] $v
                   click-redisplay
                }

                EBGO   {click-event 1}
                EBSTOP {click-event 0}
                EVCNT  {click-count $v}

		default {puts stderr "sys:  click \{$arg\}"}
	}
}
# start up routine makes the frame.

proc start args {
   global started 
   if {$started == 0} then {make-frame} else {open-frame}
   set started 1
	get-all-cards
	make-system-image
	make-d2vb-registers
   click-redisplay
   return
}

proc click-quit args {close-frame}

proc finish args {destroy-frame}

proc make-frame {} {
  global env scalercount 
  global vxireq ecreq datareq formatreq
  global vxistatus vxistate ecstate datastate formatstate

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/egarray" \
      :icon-name "[self icon-title]" :resize F

     :panel PANEL1 :layout T :padx 100 :pady 5
     :layout V; :col-gap 10; :row-gap 10
      :choice VXI     :label "VXI Electronics:"   :strings [list Stop Go Flush Reset] :valuex 20c


   :panel PANEL2B :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10
       :message MSG1 :label "Subsystems required:" :bold T :valuex 25c
         :checkbox VXIREQ    :label "VXI Electronics" :valuex 20c  :value $vxireq
         :checkbox ECREQ     :label "Event Readout" :valuex 20c  :value $ecreq
         :checkbox FORMATREQ :label "Format Check" :valuex 20c  :value $formatreq
         :checkbox DATAREQ   :label "Data Check" :valuex 20c  :value $datareq

   :panel PANEL2A :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10
       :vskip 20
       :message MSGEB  :label "Readout Tests" :bold T
       :hskip 30
       :button EBGO   :label "GO"     :w 8  :h 3 :colour green
       :button EBSTOP :label "STOP"   :w 8  :h 3 :colour red

   :panel PANEL2C :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10
       :message MSG2 :label "Subsystem States:" :bold T :valuex 25c
         :checkbox VXISTATE    :label "VXI Electronics" :valuex 20c  :value $vxistate :colours "white black" :deaf T
         :checkbox ECSTATE     :label "Event Readout" :valuex 20c  :value $ecstate :colours "white black" :deaf T
         :checkbox FORMATSTATE :label "Format Check" :valuex 20c  :value $formatstate :colours "white black" :deaf T
         :checkbox DATASTATE   :label "Data Check" :valuex 20c  :value $datastate :colours "white black" :deaf T

   :panel PANEL3 :layout B :padx 5 :pady 5 :after FOOTER
     :layout H; :col-gap 10; :row-gap 10
      :message MSGRESA :label "Results" :bold T
      :next-row T
	:text VXICOUNT :label "Events at Trigger" :read-only T :value $scalercount :w 5
      :next-row T
      :message MSGRESB :label "Test control" 
      :next-row T
      :slider EVCNT :label "Number of events" :min 1 :max 100 :resolution 1
      :layout V


   :panel BUTTONS :layout B :padx 5 :pady 5 :after FOOTER
     :layout H; :col-gap 10; :row-gap 10
      :message MSG3 :label "Controls" :bold T
     :next-row T
      :next-row T
      :button REDISPLAY   :label "Redisplay"       :command click-redisplay
      :hskip 70
      :button HELP        :command click-help

   :show T
}
 
proc get-all-cards {} {
global cardtypes cardtype chanlist

	foreach w $cardtypes {
		set cardtype $w
		make-chanlist
		set l $w
		append l "chanlist"
		global $l
		set $l $chanlist
	}

}
# set up the system table as a collection of lists of cards, and where they are ?
proc make-system-image {} {
global cardtypes cardtype chanlist chanindex cardtable cardcount 
	set cardcount 0
	foreach w $cardtypes {
		set cardtype $w
		set l $w
		append l "chanlist"
		global $l
		foreach v [ set [ set l ] ] {
			if { $v != "???" } {
				set cardtable($cardcount) [ VXImodule2crate $cardtype$v ]
				append cardtable($cardcount)  " $cardtype $v"
				incr cardcount
			}
		}
	}
}
# Use the table of cards to run the test.
proc write-check-file {} {
global cardtable cardcount fifopatterns eventcount scalercount
	set filename /MIDAS/rdotst/check-file
	set fp [ open  $filename w+  ]
	puts $fp $cardcount
	for { set n 0 } { $n < $cardcount } { incr n } {
		puts $fp $cardtable($n)
	}
	puts $fp $eventcount
	puts $fp $scalercount
	foreach v $fifopatterns {
		puts $fp $v
	}
	close $fp
}
proc make-d2vb-registers {} {
global D2VBserver
	foreach v { file dump go stop init count clear } {
		set l dvtest_
		append l $v
		if { [ ersinquire $D2VBserver $l ] == "" } {
			ersdefine $D2VBserver $l generic
		}
	}
	erswta	$D2VBserver dvtest_file { -n dvtest_file -t string }
	erswta	$D2VBserver dvtest_clear { -n dv_clear -t function }
	erswta	$D2VBserver dvtest_dump { -n dv_dump -t function }
	erswta	$D2VBserver dvtest_go { -n dvgo -t function }
	erswta	$D2VBserver dvtest_stop { -n dvstop -t function }
	erswta	$D2VBserver dvtest_init { -n dvinit -t function }
	erswta	$D2VBserver dvtest_count { -n dvtest_count -t int }
	EG "register :name '/$D2VBserver/dvtest_file' :value '/MIDAS/rdotst/dump' "
}
proc reset-d2vb-registers {} {
global D2VBserver ecreq
	if { $ecreq == 1 } {
		EG "register :name '/$D2VBserver/dvtest_stop' ?value "
		EG "register :name '/$D2VBserver/dvtest_init' ?value "
		EG "register :name '/$D2VBserver/dvtest_go' ?value "
	}
}

# write out the file with the current data, and then fetch the data from the 
proc exec-check-program {} {
global ecstate
	write-check-file
	transfer-data-to-file
	set ecstate 1
	click-redisplay
}
proc transfer-data-to-file {} {
global D2VBserver ecreq cardcount fifocount dataoverhead scalercount
	if { $ecreq == 1 } {
		set v [ expr $scalercount * $cardcount * [ expr $fifocount + $dataoverhead ] ]
		EG "register :name '/$D2VBserver/dvtest_count' :value '$v'"
		EG "register :name '/$D2VBserver/dvtest_dump' ?value "
	}

}
proc read-trigger-scalers {} {
global scalercount scalerbase resource
	EG "register :name '/$resource/TriggerMK2.XferScalers' :value  '1'" 
	EG "register :name '/$resource/TriggerMK2.XferScalers' :value  '0'" 
	EG "register :name '/$resource/TriggerMK2.XferScalers' :value  '1'" 
	set n [ expr [ EG "register :name '/$resource/TriggerMK2.Scaler6' ?value " ] ]
	set scalercount [ expr $n - $scalerbase ]
	set scalerbase $n 
}

proc make-event {} {
global cardtable cardcount togglecount triggerchanged testmodeset eventmemo eventrun afterid EGkeep1 EGreport
global vxistate ecstate datastate formatstate ecreq datareq formatreq scalercount
	set EGkeep1 $EGreport
	set EGreport -1
	if { $triggerchanged == 0 } { sync-trig-noinhibit }
	if { $testmodeset == 0 } { 
		set-all-testmode 
		set testmodeset 1
	}
	set eventmemo [expr {$eventmemo -1 }]
	for { set n 0 } { $n < $cardcount } { incr n } {
		set lcardtype [ lindex $cardtable($n) 1 ]
		set lresource [ lindex $cardtable($n) 0 ]
		set lchan     [ lindex $cardtable($n) 2 ]
		chan-enb-dis $lchan $lresource $lcardtype 1
		fifo-stuff $lchan $lresource $lcardtype
		set togglecount 1
		sync-toggle
		chan-enb-dis $lchan $lresource $lcardtype 0
	}
	set EGreport $EGkeep1
	if {$eventmemo == 0  } then {
		set eventrun 0
		set triggerchanged 0
		set testmodeset 0
		read-trigger-scalers
		:modify VXICOUNT :value $scalercount
		set vxistate 1
		clear-footer
		click-redisplay
		if { $ecreq == 1 } { exec-check-program } 
	} \
	else	{
		set-footer "$eventmemo Readout Test events still to be sent"
		set afterid [ after 20 make-event ]
	}
	
}

# stuff the full set of data into the selected channels data FIFO 
proc fifo-stuff { lchan lresource lcardtype}	{
global fifopatterns
	if { $lcardtype != "ClusterGe" } {
		set l $lcardtype 
		append l "-fifo"
		foreach v $fifopatterns {
			$l $lresource $lchan $v
		}
	}
}
proc Ge-fifo { lresource lchan pattern } {
	EG "register :name '/$lresource/Ge$lchan.FIFO.test' :value '$pattern' "
}

proc Clover-fifo { lresource lchan pattern } {
	EG "register :name '/$lresource/Clover$lchan.Ge.RdOut.FIFOTest' :value '$pattern' "
}

proc ClusterGe-fifo { lresource lchan pattern } {
	EG "register :name '/$lresource/ClusterGe$lchan.GIR.FIFO.Test' :value '$pattern' "
}

proc chan-enb-dis { lchan lresource lcardtype action}	{
		set l $lcardtype 
		append l "-enable"
		if { $lcardtype != "ClusterGe" } {
			$l $lresource $lchan $action
		}
}

proc Ge-enable { lresource lchan action } {
	EG "register :name '/$lresource/Ge$lchan.Enable' :value '$action' "
}

proc Clover-enable { lresource lchan action } {
		foreach  v { ".GeA" ".GeB" ".GeC" ".GeD" ".GeE" } {
			EG "register :name '/$lresource/Clover$lchan$v.Enable' :value '$action' "
		}
}

proc ClusterGe-enable { lresource lchan action } {
		foreach  v {  "A" "B" "C" "D" "E" "F" "G" "H"  } {
			EG "register :name '/$lresource/ClusterGe$lchan.Ge$v.Enable' :value '$action' "
		}
}
# set the Test generator value, and attenuator for each card channel,& enable the test mode each seg
# gen , attn , and mode extensions.
proc set-all-testmode {} {
global cardtable cardcount 
	for { set n 0 } { $n < $cardcount } { incr n } {
		set lcardtype [ lindex $cardtable($n) 1 ]
		set lresource [ lindex $cardtable($n) 0 ]
		set lchan     [ lindex $cardtable($n) 2 ]
		if { $lcardtype != "ClusterGe" } {
			set lsegs $lcardtype 
			append lsegs "-test-set"
			$lsegs $lresource $lchan
		}
	}
}
proc ersdefine {server register class} {
   EG "register :name '/$server/$register' :class '$class' !new"
}

proc ersinquire {server register} {
   EG "register :pattern '/$server/$register' ?names"
}

proc erswta {server register args} {
   EG "register  :name '/$server/$register' :object '$args'"
}

proc Clover-test-set { lresource lchan } {
 
	EG "register :name '/$lresource/Clover$lchan.Ge.TestGen' :value '6000000' "
	EG "register :name '/$lresource/Clover$lchan.Ge.PileupReject' :value '0' "
	EG "register :name '/$lresource/Clover$lchan.Ge.TestGen.Attn' :value '0' "
	foreach v { ".GeA" ".GeB" ".GeC" ".GeD" ".GeE" } {
	   EG "register :name '/$lresource/Clover$lchan$v.TestMode' :value '1' "
	   EG "register :name '/$lresource/Clover$lchan$v.TFAGain' :value '0' "
	   EG "register :name '/$lresource/Clover$lchan$v.CFD.Thresh' :value '0x20' "
	}
}
proc Ge-test-set { lresource lchan } {
 
	EG "register :name '/$lresource/Ge$lchan.TestGen' :value '6000000' "
	EG "register :name '/$lresource/Ge$lchan.PileupReject' :value '0' "
	EG "register :name '/$lresource/Ge$lchan.TestGen.Attn' :value '0' "
	EG "register :name '/$lresource/Ge$lchan.TestMode' :value '1' "
	EG "register :name '/$lresource/Ge$lchan.TFAGain' :value '0' "
	EG "register :name '/$lresource/Ge$lchan.CFD.Thresh' :value '0x20' "
	
}
proc ClusterGe-test-set { lresource lchan } {
 
	EG "register :name '/$lresource/ClusterGe$lchan.Ge.TestGenAmpl' :value '6000' "
	EG "register :name '/$lresource/ClusterGe$lchan.Ge.PileupReject' :value '0' "
	foreach v { "A" "B" "C" "D" "E" "F" "G" "H"  } {
	   EG "register :name '/$lresource/ClusterGe$lchan.Ge$v.TestMode' :value '1' "
	   EG "register :name '/$lresource/ClusterGe$lchan.Ge$v.TFAGain' :value '0' "
	   EG "register :name '/$lresource/ClusterGe$lchan.Ge$v.CFD.Thresh' :value '0x20' "
	}
}

