

#   rm.defn.tcl     Resource Manager VXI card


proc {AddRMModule}  {module slot}  {
   global registerbase cardtype nsockets

   set registerbase $cardtype$module

   delete-vxi-registers $registerbase.*

   RMVXIRegisters
   RMModuleRegisters
   RMVMERegisters
}

proc rm_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc RMVXIRegisters {} {
   rm_register  VXI.ManID      xSht   "-s0 -o0  -pro -w16 -fx -b0  -l12"
   rm_register  VXI.AddrSpace  xSht   "-s0 -o0  -pro -w16 -fd -b12 -l2"
   rm_register  VXI.DevClass   xSht   "-s0 -o0  -pro -w16 -fd -b14 -l2"
   rm_register  VXI.ModelCode  xSht   "-s0 -o2  -pro -w16 -fx -b0  -l12"
   rm_register  VXI.ReqMem     xSht   "-s0 -o2  -pro -w16 -fd -b12 -l4"
   rm_register  VXI.Reset      xSht   "-s0 -o4  -prw -w16 -fd -b0  -l1"
   rm_register  VXI.Passed     xSht   "-s0 -o4  -pro -w16 -fd -b2  -l1"
   rm_register  VXI.Ready      xSht   "-s0 -o4  -pro -w16 -fd -b3  -l1"
   rm_register  VXI.ModID      xSht   "-s0 -o4  -pro -w16 -fd -b14 -l1"
   rm_register  VXI.A24A32     xSht   "-s0 -o4  -pro -w16 -fd -b15 -l1"
   rm_register  VXI.Offset     xSht   "-s0 -o6  -pro -w16 -fx"
   rm_register  VXI.SerialNum  xSht   "-s0 -o8  -pro -w16 -fx"
   rm_register  VXI.ModLevel   xSht   "-s0 -o10 -pro -w16 -fx"
}

proc RMVMERegisters {} {

	rm_register   VME.Reset       digital "-a0xfffe2001 -prw -w8 -fd -b1 -l1 -i0"
	rm_register   VME.Config      digital "-a0xfffe2003 -prw     -fx         -i0x33"
	rm_register   VME.Master      digital "-a0xfffe2003 -pro -w8 -fd -b6 -l1"
	rm_register   VME.DWB         digital "-a0xfffe2003 -pro -w8 -fd -b7 -l1"
}

proc RMModuleRegisters {} {

	rm_register   Mode            xExt "-a0 -pro -fx"
	rm_register   RENO            xExt "-a0 -prw -fd -l1 -b0 -i1"
	rm_register   VXI.Enable      xExt "-a0 -prw -fd -l1 -b1 -i0"
	rm_register   VXI.Go          xExt "-a0 -prw -fd -l1 -b2 -i0"
	rm_register   VXI.Inhibit     xExt "-a0 -prw -fd -l1 -b3 -i0"
	rm_register   MemEch          xExt "-a0 -prw -fd -l1 -b4 -i0"
	rm_register   NoIPTerm        xExt "-a0 -pro -fd -l1 -b14"
	rm_register   ADC.Converted   xExt "-a0 -pro -fd -l1 -b15"

        rm_register   ADC             xADC "-n10 -d0 -qm -uV -r0:-5V,0xffff:5V"

	rm_register   Status          xExt "-a2 -pro -fx"
	rm_register   TTLTRG          xExt "-a2 -pro -fx -l8 -b0"
	rm_register   ECLTRG          xExt "-a2 -pro -fx -l6 -b8"
	rm_register   Coding          xExt "-a2 -pro -fd -l1 -b0"
	rm_register   Readout         xExt "-a2 -pro -fd -l1 -b1"
	rm_register   ScalarsXfer     xExt "-a2 -pro -fd -l1 -b2"
	rm_register   Clear           xExt "-a2 -pro -fd -l1 -b3"
	rm_register   VXI.Active      xExt "-a2 -pro -fd -l1 -b4"
	rm_register   RejectEvent     xExt "-a2 -pro -fd -l1 -b5"
	rm_register   Val3            xExt "-a2 -pro -fd -l1 -b6"
	rm_register   InhibitAction   xExt "-a2 -pro -fd -l1 -b7"
	rm_register   Val1            xExt "-a2 -pro -fd -l1 -b8"
	rm_register   SynchTrig       xExt "-a2 -pro -fd -l1 -b9"
	rm_register   InhibitRequest  xExt "-a2 -pro -fd -l1 -b10"
	rm_register   Insp.D1         xExt "-a2 -pro -fd -l1 -b11"
	rm_register   Insp.D2         xExt "-a2 -pro -fd -l1 -b12"
	rm_register   Val2            xExt "-a2 -pro -fd -l1 -b13"
}


proc RM_DAQ-reset   {args}   {
   set module [first $args]
}

proc RM_DAQ-halt   {args}   {
   set module [first $args]
#    no action
}

proc RM_DAQ-go   {args}   {
   set module [first $args]
}
