

#   saphir.defn.tcl     Saphir VXI card


proc {AddSaphirModule}  {module slot}  {
   global registerbase cardtype nsockets

   set registerbase $cardtype#$module

   delete-vxi-registers $registerbase.*

   SaphirVXIRegisters $slot
   SaphirModuleRegisters $slot

   for {set socket 1} {$socket <= $nsockets} {incr socket} {

        set registerbase $cardtype[expr $module * $nsockets + $socket - 1]

        delete-vxi-registers $registerbase.*

#    first a register to record module each channel is in
        saphir_register  ModuleName    generic "-n$cardtype#$module -tstring -pro"

        SaphirVXIRegisters $slot
        SaphirModuleRegisters $slot

        AddSaphirDetector $slot $socket
   }
}

proc AddSaphirDetector {slot socket} {

  SaphirSIROPRegisters1 $slot $socket
  SaphirSIROPRegisters2 $slot $socket
  SaphirSIROPRegisters3 $slot $socket

  SaphirDetectorRegisters  $slot $socket
}

proc saphir_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc SaphirVXIRegisters {slot} {
   saphir_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   saphir_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   saphir_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   saphir_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   saphir_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   saphir_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   saphir_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   saphir_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   saphir_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   saphir_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   saphir_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   saphir_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   saphir_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
}

proc SaphirModuleRegisters {slot} {
   global registerbase

#    common area registers

        saphir_register TestGenAmpl       xDAC "-s$slot -o0x00 -w16 -pwo -qk -ueV -d0 -r0:20MeV,0xffff:0KeV -i4keV"

        saphir_register MCR               xDig "-s$slot -o0x10 -w16 -prw -fx -b0 -l0    "
        saphir_register PileupReject      xDig "-s$slot -o0x10 -w16 -prw -fd -b0 -l1 -i0"
        saphir_register TestGenEnable     xDig "-s$slot -o0x10 -w16 -prw -fd -b1 -l1 -i0"
        saphir_register FIFO.Reset        xDig "-s$slot -o0x10 -w16 -prw -fd -b8 -l1 -i1"
        saphir_register GIR.Reset         xDig "-s$slot -o0x10 -w16 -prw -fd -b9 -l1    "
        saphir_register LastCard          xDig "-s$slot -o0x10 -w16 -prw -fd -b10 -l1   "

	saphir_register   DSP.Reset     xDig    "-s$slot  -o0x10 -w16 -prw -fd -b14 -l1 -i0"

        saphir_register Insp.D1.Channel   xMux "-s$slot -o0x20 -w16 -prw -b0 -l16 -dSaphir -md1"
        saphir_register Insp.D1.Signal    xDig "-s$slot -o0x22 -w16 -prw -fd -b0 -l0 -i0"
        saphir_register Insp.D2.Channel   xMux "-s$slot -o0x24 -w16 -prw -b0 -l16 -dSaphir -md2"
        saphir_register Insp.D2.Signal    xDig "-s$slot -o0x26 -w16 -prw -fd -b0 -l0 -i0"
        saphir_register Insp.A1.Channel   xMux "-s$slot -o0x28 -w16 -prw -b0 -l16 -dSaphir -ma1"
        saphir_register Insp.A1.Signal    xDig "-s$slot -o0x2a -w16 -prw -fd -b0 -l0 -i0"
        saphir_register Insp.A2.Channel   xMux "-s$slot -o0x2c -w16 -prw -b0 -l16 -dSaphir -ma2"
        saphir_register Insp.A2.Signal    xDig "-s$slot -o0x2e -w16 -prw -fd -b0 -l0 -i0"
        saphir_register Insp.V.Channel    xMux "-s$slot -o0x30 -w16 -prw -b0 -l16 -dSaphir -mv"
        saphir_register Insp.V.Signal     xDig "-s$slot -o0x32 -w16 -prw -fd -b0 -l0 -i0"

	saphir_register   GIR.DSP.Control     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b0 -l0"
	saphir_register   GIR.DSP.Control.DSPtotcount     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b3 -l1"
	saphir_register   GIR.DSP.Control.FIlterMode     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b1 -l1"
	saphir_register   GIR.DSP.ExtMem     bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
	saphir_register   GIR.DSP.IntMem     bVXI    "-s$slot  -a0x400000 -o0x0 -w32 -pro -fx -l64"
	saphir_register   GIR.DSP.Item       xDig    "-s$slot  -a0x400000 -o0x98004 -w32 -prw -fd -b0 -l0"
	saphir_register   GIR.DSP.Spectre     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b8 -l1"
	saphir_register   GIR.DSP.Scaler     xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b9 -l1"
	saphir_register   GIR.DSP.Program    xGIR    "-s$slot  -a0x400010 -l0"
	saphir_register   GIR.DSP.ResetDSP   xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b4 -l1"
	saphir_register   GIR.DSP.ResetMemExt   xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b7 -l1"
	saphir_register   GIR.DSP.SpectrumData     bVXI    "-s$slot  -a0x200000 -o0x0 -w32 -pro -fx -l64"
	saphir_register   GIR.DSP.StartDSP   xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b0 -l1"
	saphir_register   GIR.DSP.StopDSP    xDig    "-s$slot  -a0x400000 -o0xbff40 -w32 -prw -fd -b2 -l1"
	saphir_register   datal     xDig    "-s $slot  -c0 -o0x0 -w32 -fx -prw"
	saphir_register   dataw     xDig    "-s $slot  -c0 -o0x0 -w16 -fx -prw"

	saphir_register   BufferSetup.Volatile.DAC0   xDig    "-s$slot  -o0x80 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC1   xDig    "-s$slot  -o0x82 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC2   xDig    "-s$slot  -o0x84 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC3   xDig    "-s$slot  -o0x86 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC4   xDig    "-s$slot  -o0x88 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC5   xDig    "-s$slot  -o0x8a -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC6   xDig    "-s$slot  -o0x8c -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC7   xDig    "-s$slot  -o0x8e -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC8   xDig    "-s$slot  -o0x90 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC9   xDig    "-s$slot  -o0x92 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC10  xDig    "-s$slot  -o0x94 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC11  xDig    "-s$slot  -o0x96 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC12  xDig    "-s$slot  -o0x98 -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC13  xDig    "-s$slot  -o0x9a -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC14  xDig    "-s$slot  -o0x9c -w16 -pwo -fx -b0 -l0 -i255"
	saphir_register   BufferSetup.Volatile.DAC15  xDig    "-s$slot  -o0x9e -w16 -pwo -fx -b0 -l0 -i255"

#    GIR registers

        saphir_register GIR.EvNum.Count    xDig "-s$slot -o0xA0 -w16 -prw -fx -b0 -l0 -i0"
        saphir_register GIR.EvNum.Addr     xAdr "-s$slot -c0 -o0xA2 -w16 -i$registerbase.GIR.EvNum"
        saphir_register GIR.EvNum          xDig "-s$slot -o0xA0 -w32 -pro -fx -b0 -l0    "
        saphir_register GIR.FIFO.Test      xFIT "-s$slot -o0xA4 -w32 -prw -fx"
        saphir_register GIR.ROTSR          xDig "-s$slot -o0xAC -w16 -pro -fx -b0 -l0    "
        saphir_register GIR.ValAck.TimeOut xDAC "-s$slot -c0 -a0 -z0 -o0xAE -w16 -prw -qn -us -d0 -r0:0s,0xffff:4096000ns -i100000ns"
        saphir_register GIR.Qstat0         xDig "-s$slot -o0xB0 -w32 -pro -fd -b0 -l16    "
        saphir_register GIR.Qstat1         xDig "-s$slot -o0xB0 -w32 -pro -fd -b16 -l16    "

        saphir_register GIR.ROCR                      xDig "-s$slot -o0xA8 -w16 -prw -fx -b0 -l0 -i0"
        saphir_register GIR.ROCR.SAROC.Test           xDig "-s$slot -o0xA8 -w16 -prw -fx -b0 -l1    "
        saphir_register GIR.ROCR.Ext.Test             xDig "-s$slot -o0xA8 -w16 -prw -fx -b1 -l1    "
        saphir_register GIR.ROCR.ValAck.TimeOutReset  xDig "-s$slot -o0xA8 -w16 -prw -fx -b2 -l1 -i1"
        saphir_register GIR.ROCR.ReadOut.Disable      xDig "-s$slot -o0xA8 -w16 -prw -fx -b3 -l1    "
        saphir_register GIR.ROCR.PipeLine.Enable      xDig "-s$slot -o0xA8 -w16 -prw -fx -b5 -l1    "
        saphir_register GIR.ROCR.EvNumData.Disable    xDig "-s$slot -o0xA8 -w16 -prw -fx -b6 -l1 -i1"
        saphir_register GIR.ROCR.ReadOutMode          xDig "-s$slot -o0xA8 -w16 -prw -fx -b7 -l1 -i0"
        saphir_register GIR.ROCR.DSPEN                xDig "-s$slot -o0xA8 -w16 -prw -fx -b8 -l1 -i0"
        saphir_register GIR.ROCR.MODEDMA              xDig "-s$slot -o0xA8 -w16 -prw -fx -b9 -l1 -i0"
        saphir_register GIR.ROCR.EvNumQbits.Enable    xDig "-s$slot -o0xA8 -w16 -prw -fx -b11 -l1 -i1"

        saphir_register GIR.ROTSR.Temp.Status            xDig "-s$slot -o0xAC -w16 -pro -fx -b0 -l2 "
        saphir_register GIR.ROTSR.ValAck.TimeOut.Status  xDig "-s$slot -o0xAC -w16 -pro -fx -b8 -l1 "
        saphir_register GIR.ROTSR.FIFO.Status            xDig "-s$slot -o0xAC -w16 -pro -fx -b9 -l2 "
        saphir_register GIR.ROTSR.SAROC.Status           xDig "-s$slot -o0xAC -w16 -pro -fx -b11 -l1 "
        saphir_register GIR.ROTSR.EvFault.Status         xDig "-s$slot -o0xAC -w16 -pro -fx -b13 -l3 "
}


set SaphirDataBits(Energy) 13
set SaphirDataBits(Timing) 13

proc SaphirSIROPRegisters1 {slot socket} {
   global registerbase

       set c [expr $socket - 1]
       if {$socket <= 8} then {set a 0x100} else {set a 0x200}

        saphir_register   Energy.Addr      xAdr "-s$slot -c$c -a$a -z8 -o0x00 -w32 -i$registerbase.Energy"
        saphir_register   Energy.TestData  xDig "-s$slot -c$c -a$a -z8 -o0x00 -w32 -prw -fx -b16 -l0"
        saphir_register   Energy.TestRd    xDig "-s$slot -c$c -a$a -z8 -o0x00 -w32 -pro -fx -b16 -l0"

        saphir_register   Timing.Addr      xAdr "-s$slot -c$c -a$a -z8 -o0x04 -w32 -i$registerbase.Timing"
        saphir_register   Timing.TestData  xDig "-s$slot -c$c -a$a -z8 -o0x04 -w32 -prw -fx -b16 -l0"
        saphir_register   Timing.TestRd    xDig "-s$slot -c$c -a$a -z8 -o0x04 -w32 -pro -fx -b16 -l0"
}

proc SaphirSIROPRegisters2 {slot socket} {

       if {$socket <= 8} then {
          set a 0x100
          set b [expr [expr $socket - 1] * 2]
       } else {
          set a 0x200
          set b [expr [expr $socket - 9] * 2]
       }

        saphir_register   Energy.Dtready    xDig "-s$slot -c0 -a$a  -o0x40 -w32 -prw -fd -b$b -l1 -i0"
        saphir_register   Energy.ROEnable   xDig "-s$slot -c0 -a$a  -o0x44 -w32 -prw -fd -b$b -l1 -i1"
        saphir_register   Energy.ShiftCtrl  xDig "-s$slot -c0 -a$a  -o0x44 -w32 -prw -fd -b16 -l2 -i2"
        saphir_register   Energy.SSEnable   xDig "-s$slot -c0 -a$a  -o0x44 -w32 -prw -fd -b18 -l1 -i0"

        saphir_register   SSRange           xDig "-s$slot -c0 -a$a  -o0x44 -w32 -prw -fd -b19 -l1 -i0"
        saphir_register   SlidingScale      xDig "-s$slot -c0 -a$a  -o0x48 -w32 -prw -fd -b0 -l0"
}

proc SaphirSIROPRegisters3 {slot socket} {

       if {$socket <= 8} then {
          set a 0x100
          set b [expr [expr [expr $socket - 1] * 2] + 1]
       } else {
          set a 0x200
          set b [expr [expr [expr $socket - 9] * 2] + 1]
       }

        saphir_register   Timing.Dtready    xDig "-s$slot -c0 -a$a  -o0x40 -w32 -prw -fd -b$b -l1 -i0"
        saphir_register   Timing.ROEnable   xDig "-s$slot -c0 -a$a  -o0x44 -w32 -prw -fd -b$b -l1 -i1"
        saphir_register   Timing.ShiftCtrl  xDig "-s$slot -c0 -a$a  -o0x44 -w32 -prw -fd -b16 -l2 -i2"
        saphir_register   Timing.SSEnable   xDig "-s$slot -c0 -a$a  -o0x44 -w32 -prw -fd -b18 -l1 -i0"
}

proc SaphirDetectorRegisters {slot socket} {

        set c [expr $socket - 1]

        saphir_register   CFD.Delay    xDAC "-s$slot -c$c -a0x1000 -z0x100 -o0x00 -w16 -pwo -qn -us -d0 -r0:0s,0xff:550ns -i100ns"
        saphir_register   CFD.Thresh   xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x02 -w16 -pwo -fd -b0 -l0 -i128"
        saphir_register   CFD.Width    xDAC "-s$slot -c$c -a0x1000 -z0x100 -o0x04 -w16 -pwo -qn -us -d0 -r0:0s,0xff:550ns -i50ns"
        saphir_register   ValSample    xDAC "-s$slot -c$c -a0x1000 -z0x100 -o0x06 -w16 -pwo -qn -us  -d0 -r0:0s,0xff:10us    -i2.51us"
        saphir_register   FTSample     xDAC "-s$slot -c$c -a0x1000 -z0x100 -o0x08 -w16 -pwo -qn -us  -d0 -r0:0s,0xff:3.2us   -i515ns"
        saphir_register   PDSGate      xDAC "-s$slot -c$c -a0x1000 -z0x100 -o0x0a -w16 -pwo -qn -us  -d0 -r0:0s,0xff:10us    -i6.5us"

        saphir_register   CCR           xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -w16 -prw -fx -b0 -l0"
        saphir_register   CCR.Amp       xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -w16 -prw -fd -b0 -l1 -i0"
        saphir_register   CCR.TestGen   xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -w16 -prw -fd -b1 -l1 -i0"
        saphir_register   TestMode      xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -w16 -prw -fd -b1 -l1 -i0"
        saphir_register   CCR.Enable    xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -g1 -w16 -prw -fd -b2 -l1 -i0"
        saphir_register   Enable        xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -g1 -w16 -prw -fd -b2 -l1 -i0"
        saphir_register   CCR.InvertPDS xDig "-s$slot -c$c -a0x1000 -z0x100 -o0x10 -w16 -prw -fd -b3 -l1 -i0"
}


proc Saphir_DAQ-reset   {args}   {
   set module [first $args]
#    flush FIFOs
   write-vxi-register $module.FIFO.Reset 0
   write-vxi-register $module.FIFO.Reset 1
   write-vxi-register $module.FIFO.Reset 0
#    reset and enable GIR
   write-vxi-register $module.GIR.FIFO.Test 0
   read-vxi-register $module.GIR.FIFO.Test
}


proc Saphir_DAQ-halt   {args}   {
   set module [first $args]
#    no action
}


proc Saphir_DAQ-go   {args}   {
   set module [first $args]
#    zero event numbers
   write-vxi-register $module.GIR.EvNum.Count 0
}
