# clusterbgo.tcl     cluster card BGO channel control

#  created 2-2-96  VP  from cluster ge

set debug 0
set started 0

set frame TGIRBGA
set frametitle "TGIR BGA Channel Setup"
set icontitle  "TGIR BGA"

set chanlist {???}
set chanindex 0
set seglist {A B C D}
set segindex 0
set defaultchanlist {0 1 2 3 4 5 6 7}

set cardtype TGIR
set chantype BGO
set VXIGlobal ""


#    The array "table" which is indexed by the "widget name" contains all the information
#    needed for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for regsiter access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"

set table(CHANNEL) {channel widget->channel channel->widget nil
        nil nil nil nil nil nil nil 1 nil}
set table(FTGATE)    {ftgate    slider-widget->param param->int-widget "FT_Gate"
                     unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Fast Trigger Gate (ns)"}
set table(FTDELAY) { ftdelay slider-widget->param param->int-widget "FT_Delay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Fast Trigger Delay (ns)"}
set table(VALGATE) {valgate slider-widget->param param->int-widget "Valid_Gate"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Validation Gate (ns)"}
set table(VALDELAY) {valdelay slider-widget->param param->int-widget "Valid_Delay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Validation Delay (ns)"}
set table(INHGATE) {inhgate slider-widget->param param->int-widget "Inhibit_Gate"
       unit-reg->param param->unit-reg ns :slider 0 65635 1 1 "Inhibit Gate (ns)"}

set table(SIMSTARTTR) {simstarttr int-widget->param param->int-widget "SimStartTrig"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Sim StartTrig"}
set table(REGAP11W)    {regap11w    hex-widget->param param->hex-widget "GIR.AP1.Buf1W"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP1Buf1w"}
set table(REGAP12W)    {regap12w    hex-widget->param param->hex-widget "GIR.AP1.Buf2W"
                    int-reg->param param->int-reg nil :text nil nil nil 1 "AP1Buf2w"}
set table(REGAP13W)    {regap13w    hex-widget->param param->hex-widget "GIR.AP1.Buf3W"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP1Buf3w"}
set table(REGAP22W)    {regap22w    hex-widget->param param->hex-widget "GIR.AP2.Buf2W"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP2Buf2w"}
set table(REGAP31W)    {regap31w    hex-widget->param param->hex-widget "GIR.AP3.Buf1W"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP3Buf1w"}
set table(REGAP32W)    {regap32w    hex-widget->param param->hex-widget "GIR.AP3.Buf2W"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP3Buf2w"}
set table(REGAP33W)    {regap33w    hex-widget->param param->hex-widget "GIR.AP3.Buf3W"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP3Buf3w"}
set table(REGAP11R)    {regap11r    hex-widget->param param->hex-widget "GIR.AP1.Buf1R"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP1Buf1r"}
set table(REGAP12R)    {regap12r    hex-widget->param param->hex-widget "GIR.AP1.Buf2R"
                    int-reg->param param->int-reg nil :text nil nil nil 1 "AP1Buf2r"}
set table(REGAP13R)    {regap13r    hex-widget->param param->hex-widget "GIR.AP1.Buf3R"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP1Buf3r"}
set table(REGAP21R)    {regap21r    hex-widget->param param->hex-widget "GIR.AP2.Buf1R"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP2Buf1r"}
set table(REGAP22R)    {regap22r    hex-widget->param param->hex-widget "GIR.AP2.Buf2R"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP2Buf2r"}
set table(REGAP31R)    {regap31r    hex-widget->param param->hex-widget "GIR.AP3.Buf1R"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP3Buf1r"}
set table(REGAP32R)    {regap32r    hex-widget->param param->hex-widget "GIR.AP3.Buf2R"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP3Buf2r"}
set table(REGAP33R)    {regap33r    hex-widget->param param->hex-widget "GIR.AP3.Buf3R"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "AP3Buf3r"}


# Electronis frame

set table(MODELCODE) {modcode str-widget->param param->hex-widget "VXI.ModelCode" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(SERIALNUM) {serialnum str-widget->param param->hex-widget "VXI.SerialNum" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MODLEVEL) {modlevel str-widget->param param->hex-widget "VXI.ModLevel" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MANID) {manid str-widget->param param->hex-widget "VXI.ManID" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(OFFSET) {offset str-widget->param param->hex-widget "VXI.Offset" 
   int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(LASTCARD) {lastcard int-widget->param param->int-widget "LastCard"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Last Card"}
set table(RESETFIFO) {resetfifo int-widget->param param->int-widget "FIFO.Reset"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Fifo Reset"}
set table(RESETDSP) {resetdsp int-widget->param param->int-widget "DSP.Reset"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "DSP Reset"}
set table(RESETGIR) {resetgir int-widget->param param->int-widget "ResetGIR"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "GIR Reset"}

set table(TDCRDMAENABLE) {tdcrdmaenable int-widget->param param->int-widget "TDCR.DataXfer1.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDCR DataXfer1"}
set table(TDCRDATAGIR) {tdcrdatagir int-widget->param param->int-widget "TDCR.DataGIR.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDCR DataGIR"}
set table(TDCRLINK4) {tdcrlink4 int-widget->param param->int-widget "TDCR.Link4.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDCR Link4"}
set table(TDCRDMATEST) {tdcrdmatest int-widget->param param->int-widget "TDCR.DMA.TEST"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDCR DMA"}

set table(ENABLE) {enable int-widget->param param->int-widget "TRCR.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TRCR Enable"}
set table(TRCRTSTBOARDEN) {trcrtstboarden int-widget->param param->int-widget "TRCR.TestBoard.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TestBoard En"}
set table(TRCRFP0EN) {trcrfp0en int-widget->param param->int-widget "TRCR.FP0.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "FP0 Enable"}
set table(TRCRFP1EN) {trcrfp1en int-widget->param param->int-widget "TRCR.FP1.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "FP1 Enable"}
set table(TRCRFP2EN) {trcrfp2en int-widget->param param->int-widget "TRCR.FP2.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "FP2 Enable"}

set table(TSRINACTGIR) {tsrinhibit int-widget->param param->int-widget "TSR.InhActGIR.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Inh_Act GIR ON"}
set table(TSRINACTRM) {tsreventfault int-widget->param param->int-widget "TSR.InhActRM.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Inh_Action RM ON"}

set table(TRAZDSP) {trazdsp int-widget->param param->int-widget "TDSP.Reset"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TDSP Reset"}
set table(TRAZLCA) {trazlca int-widget->param param->int-widget "TRAZ.LCA"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TRAZ LCA"}
set table(TRAZBOARD) {trazboard int-widget->param param->int-widget "TRAZ.Board"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TRAZ Board"}

set table(RMVALID1) {rmvalid1 int-widget->param param->int-widget "RM_Reg.valid1"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg valid1"}
set table(RMVALID2) {rmvalid2 int-widget->param param->int-widget "RM_Reg.valid2"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg valid2"}
set table(RMSYNCHT) {rmsyncht int-widget->param param->int-widget "RM_Reg.syncht"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg syncht"}
set table(RMGOSTOP) {rmgostop int-widget->param param->int-widget "RM_Reg.gostopRM"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg gostopRM"}
set table(RMMEMECH) {rmmemech int-widget->param param->int-widget "RM_Reg.memechRM"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg memechRM"}
set table(RMRAZ) {rmraz int-widget->param param->int-widget "RM_Reg.razRM"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg razRM"}
set table(INHREQRM) {inhreqrm int-widget->param param->int-widget "RM_Reg.inhreqRM"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg inhreqRM"}
set table(REJEVT) {rejevt int-widget->param param->int-widget "RM_Reg.rejectEvt"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg rejectEvt"}
set table(FINCODE) {fincode int-widget->param param->int-widget "RM_Reg.fincode"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg fincode"}
set table(FINLECT) {finlect int-widget->param param->int-widget "RM_Reg.finlect"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "RM_Reg finlect"}

# Test Salti Frame

set table(MSLSCR) {msrscr int-widget->param param->int-widget "MSL.SCR" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "MSl SCR"}
set table(DTDSEL) {dtdsel int-widget->param param->int-widget "MSL.EDR" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "MSl EDR"}
set table(DTHTHSEG0) { dtdthseg0 slider-widget->param param->int-widget "DTD.Thresh0"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "DTD Thresh0"}
set table(DTHTHSEG1) { dtdthseg1 slider-widget->param param->int-widget "DTD.Thresh1"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "DTD Thresh1"}
set table(DTHTHSEG2) { dtdthseg2 slider-widget->param param->int-widget "DTD.Thresh2"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "DTD Thresh2"}
set table(DTHTHSEG3) { dtdthseg3 slider-widget->param param->int-widget "DTD.Thresh3"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "DTD Thresh3"}
set table(DTHTHSEGS) { dtdthsegs slider-widget->param param->int-widget "DTD.ThreshS"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "DTD ThreshS"}


set table(PDSWTH) { pdswth slider-widget->param param->int-widget "PDS_Width"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "PDS Width"}
set table(PDSDEL) { pdsdel slider-widget->param param->int-widget "PDS_Delay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "PDS Gate Delay"}
set table(VALSAMWTH) { valsamwth slider-widget->param param->int-widget "Val_Sample"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Val Sample"}
set table(WATDOGSAM) { watdogsam slider-widget->param param->int-widget "Watchdog_Sample"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "Watchdog Sample"}


set table(CRCCLOVERMODE) {crcclovermode int-widget->param param->int-widget "CRC.CloverMode" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRC CloverMode"}
set table(CRCSTOPMODE) {crcstopmode int-widget->param param->int-widget "CRC.StopMode" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRC StopMode"}
set table(SALTIRDT) {saltirdt int-widget->param param->int-widget "CRC.SaltiRdt"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRC SaltiRdt"}
set table(CRCSTARTMODE) {crcstartmode int-widget->param param->int-widget "CRC.StartMode" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRC StartMode"}
set table(SCALERS) {scalers int-widget->param param->int-widget "CRC.ScalerEn"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRC ScalerEn"}
set table(VETO) {veto int-widget->param param->int-widget "CRC.VetoMode" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRC VetoMode"}
set table(SS) {ss int-widget->param param->int-widget "CRC.SS.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRC SS En"}
set table(SSMODE) {ssmode int-widget->param param->int-widget "CRC.SSMax" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRC SS Max"}
set table(INHREQ) {inhreq int-widget->param param->int-widget "CRC.InhReq"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRC InhReq"}
set table(LATCHSCALER) {latchscaler int-widget->param param->int-widget "CRC.LatchScalers"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRC LatchScalers"}

set table(SSCOUNTER)    {sscounter    hex-widget->param param->hex-widget "SS.Counter"
                     int-reg->param param->int-reg nil :text nil nil nil 1 "SS Counter"}
set table(SSPULSE) {sspulse int-widget->param param->int-widget "SS.Pulse"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "SS Pulse"}
set table(CFDEN) {cfden int-widget->param param->int-widget "TSRC.CFD.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TSRC CFD En"}
set table(CFDDIR) {cfddir int-widget->param param->int-widget "TSRC.CFD.Dir" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "TSRC CFD Dir"}
set table(TSALTIRDT) {tsaltirdt int-widget->param param->int-widget "TSRC.TSalti.Rdt"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TSRC TSalti Rdt"}
set table(LINKACK) {linkack int-widget->param param->int-widget "TSRC.LinkAck.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TSRC LinkAck En"}

set table(FTSAMP) { ftsamp slider-widget->param param->int-widget "FT.Delay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "FTSamp Delay"}
set table(CRCRADCRDT) {crcadcrdt int-widget->param param->int-widget "CRCR.ADC.En" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRCR ADC En"}
set table(CRCRTDCRDT) {crcadcrdt int-widget->param param->int-widget "CRCR.TDC.En" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRCR TDC En"}
set table(SPAREEN) {spareen int-widget->param param->int-widget "CRCR.Spare.En"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRCR Spare En"}
set table(SPSEGSEL) {spsegsel int-widget->param param->int-widget "CRCR.Spare.Setup" 
       int-reg->param param->int-reg nil :choice   nil nil nil 1 "CRCR Spare Setup"}
set table(CRYSLTEN) {cryslten int-widget->param param->int-widget "CRCR.LT.Cr"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRCR LT Cr"}
set table(CRYSTDCEN) {crystdcen int-widget->param param->int-widget "CRCR.TDC.Cr"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "CRCR TDC Cr"}

set registersavepatterns {
   FT_Gate FT_Delay Valid_Gate Valid_Delay Inhibit_Gate GIR.ROCR GIR.ValAck.TimeOut
}
#   TRCR.Enable


# inspection tables must be in same order as entries in the :choice-stacks
# this is achieved by using these tables when generating the choices
# index number returned maps directly to the signal number to be written to 
# the Signal Select register

set insp_table(MUX-AI1) {"Insp.A1" AI}
set insp_table(MUX-AI2) {"Insp.A2" AI}
set insp_table(MUX-DI1) {"Insp.D1" DI}
set insp_table(MUX-DI2) {"Insp.D2" DI}
set insp_table(MUX-VI)  {"Insp.V"  VI}

set insp_menu(MUX-AI1) analogueinsptable
set insp_menu(MUX-AI2) analogueinsptable
set insp_menu(MUX-DI1) digitalinsptable
set insp_menu(MUX-DI2) digitalinsptable
set insp_menu(MUX-VI)  voltageinsptable

set inspection_widgetnames {MUX-AI1 MUX-AI2 MUX-DI1 MUX-DI2 MUX-VI}
set inspection_regnames    {Insp.A1 Insp.A2 Insp.D1 Insp.D2 Insp.V}

#    the inspection line tables are in parallel
#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

set analogueinsptable {Disconnected
	PDS0 LA0 TFA0 In_Anal0 PDS1 LA1 TFA1 In_Anal1 PDS2 LA2
	TFA2 In_Anal2 PDS3 LA3 TFA3 In_Anal3 PDSSP LASP TFASP In_AnalSP 
	AGene-In}

set AI-ChanSelect {0 
	1 1 1 1 2 2 2 2 3 3
	3 3 4 4 4 4 5 5 5 5 6}

set AI-Param      {*
	1 2 3 4 1 2 3 4 1 2
	3 4 1 2 3 4 1 2 3 4 0}

set analogueinspmenu {Disconnected
	{"Test_Salti" PDS0 LA0 TFA0 In_Anal0 PDS1 LA1 TFA1 In_Anal1 PDS2 LA2
	TFA2 In_Anal2 PDS3 LA3 TFA3 In_Anal3 PDSSP LASP TFASP In_AnalSP}
	 AGene-In}

set voltageinsptable {Disconnected VGene-In}
set VI-ChanSelect {0 1}
set VI-Param      {* 0}


set digitalinsptable {Disconnected
       Ext-Input0 Ext-Input1 Ext-Input2 FT-GIR FT-GIR-ECL FT-RM Validation Val-RM Inh-Action-In Inh-Action-RM 
       Inh-Req-In Inh-Req-RM GO-Stop-RM MARB-Arr Valack-GIR StartReadout-GIR Renin-GIR DtReady-GIR Dtack-GIR LPass-GIR 
       Irq0-Dsp Start-DMA DMA-Req DMA-Grant HBR-Dsp HBG-Dsp Redy-Dsp CS-Dsp Rd-Dsp Wr-Dsp 
       MS1-Dsp CS-Sram We-Sram Oe-Sram OeAdd-Dsp OeData-Dsp DirData-Dsp Timexp Flag1-Dsp  Flag2-Dsp 
       Flag3-Dsp OeAdd-TGIR OeData-TGIR DirData-TGIR Wr-Strobe Clk-By-2 spare1 spare2 OeData-APBuf0 OeData-APBuf1 
	OeData-APBuf2 OeData-APBuf3 OeData-APBuf4 OeData-APBuf5

	DDS_CR00 DDS_CR01 DDS_CR02 DDS_CR03 DDS_CR04 DS1_CR00 DS1_CR01 DS1_CR02 DS1_CR03 DS1_CR04 
	Data_ADC00 Data_ADC01 Data_ADC02 Data_ADC03 Data_ADC04 Busy_ADC0 MSL_DtAck AMux_RdOe AMux_DataSeg AMux_OeSeg
	AMux_ClkSeg AMux_DataSp AMux_OeSp AMux_ClkSp CRD0_Cr0 CRD0_Cr1 CRD0_Cr2 CRD0_Cr3 anamuxseg anamuxspare blr4

	DDS0 DDS1 DDS2 DDS3  PDS_Gate PDS_Reset FT_Sample Val_Sample BLR_Out Encod_Command
	ADC_CVT ADC_Busy ADC_Clk ADC_Coding End_ADC_Rdt Timeout_Rst CFD_Inner DtReady Renout AddRam_Run0
	Veto_Flag ADC_Shift&Ce DDS_Sp
 	 
	CFD_FP Veto_FP FT Val(unused) Inh(unused) Renin Orvalack StartRdt DtReady_Salti
	DtAck LTReset_in Wr_Strobe Resetfifo SS_Data SS_Clk SS_Strobe Link_Clk Link_Oe Link_Ack Link_Data0 
	Link_Data1 Link_Data2 Link_Data3

	StopCounter Latch_Seg_Pat Scaler_Cnt_Ce Wr_Scaler_Sram Ld_Scaler_oldVal Incr_Scaler Wr_Scaler Rst_Scaler 
	Start_Rst_Scal Oe_Scaler 

       Fast_Trigger Inhibit Validation Event-Reject Counter-En Valack Coding-Bus StartReadout Renin DTready 
       DtAck LPass ClkA-Fifo EnA-Fifo Flag0-Dsp Flag1-Dsp Flag2-Dsp Flag3-Dsp Irq0-Dsp Irq1-Dsp 
       Inh-Req AS-VME* DS-VME R/W-VME* ModRoco Card-Renin* BLTACK-Card BLTACK-Bus FDTACK DTACK-Bus* 
       Decode-Sel Oe_Card Lt_Reset ClkB-Fifo EnB-Fifo Empty-Fifo Reset-Fifo Sysclk LINK-CE DMA-Req 
       DMA-Grant Link4-Start Link4-Ack Link4-Clk Link4-Dat0 Link4-Dat1 Link4-Dat2 Link4-Dat3 Dtack-VXI Oe-DSP-Data-Run 
       Evt-Cpt-Ce  Rdt-Evt-Fault Rdt-Evt-Match Wr-DSP Rd-DSP CS-DSP OeAdd-DSP MS1-DSP HBR-DSP HBG-DSP 
       CS-Sram We-Sram Oe-Sram
}

# Channel Values for digital inspection lines : 
# 0 disconnected
# 1 Salti Cristal A
# 2 Salti Cristal B
# 3 Salti Cristal C
# 4 Salti Cristal D
# 5 Salti 
# 6 Salti
# 7 MSL
# 8 TGIR
# 32 GIR


set DI-ChanSelect {0
	8 8 8 8 8 8 8 8 8 8 
        8 8 8 8 8 8 8 8 8 8
	8 8 8 8 8 8 8 8 8 8
        8 8 8 8 8 8 8 8 8 8
	8 8 8 8 8 8 8 8 8 8
        8 8 8 8
	7 7 7 7 7 7 7 7 7 7
	7 7 7 7 7 7 7 7 7 7
	7 7 7 7 7 7 7 7 7 7 7
	* * * * * * * * * *
 	* * * * * * * * * *
	* * *
	5 5 5 5 5 5 5 5 5 5
	5 5 5 5 5 5 5 5 5 5
	5 5 5
	6 6 6 6 6 6 6 6 6 6
        32 32 32 32 32 32 32 32 32 32 
        32 32 32 32 32 32 32 32 32 32 
        32 32 32 32 32 32 32 32 32 32 
        32 32 32 32 32 32 32 32 32 32 
        32 32 32 32 32 32 32 32 32 32
        32 32 32 32 32 32 32 32 32 32
        32 32 32 
}

set DI-Param      {*
	1 2 3 4 5 6 7 8 9 10
        11 12 13 14 15 16 17 18 19 20
	21 22 23 24 25 26 27 28 29 30
        31 32 33 34 35 36 37 38 39 40	
	41 42 43 44 45 46 47 48 49 50
        51 52 53 54
	1 2 3 4 5 6 7 8 9 10
	11 12 13 14 15 16 17 18 19 20
	21 22 23 24 25 26 27 28 29 30 31
	1 2 3 4 5 6 7 8 9 10
	11 12 13 14 15 16 17 18 19 20
	21 22 23
	1 2 3 4 5 6 7 8 9 10
	11 12 13 14 15 16 17 18 19 20
	21 22 23
	1 2 3 4 5 6 7 8 9 10
        1 2 3 4 5 6 7 8 9 10
        11 12 13 14 15 16 17 18 19 20
        21 22 23 24 25 26 27 28 29 30 
        31 32 33 34 35 36 37 38 39 40 
        41 42 43 44 45 46 47 48 49 50
        51 52 53 54 55 56 57 58 59 60
        61 62 63
}


set digitalinspmenu {Disconnected
       {"TGIR Signals #1" Ext-Input0 Ext-Input1 Ext-Input2 FT-GIR FT-GIR-ECL FT-RM Validation Val-RM Inh-Action-In Inh-Action-RM 
       Inh-Req-In Inh-Req-RM GO-Stop-RM MARB-Arr Valack-GIR StartReadout-GIR Renin-GIR DtReady-GIR Dtack-GIR LPass-GIR }

       {"TGIR Signals #2" Irq0-Dsp Start-DMA DMA-Req DMA-Grant HBR-Dsp HBG-Dsp Redy-Dsp CS-Dsp Rd-Dsp Wr-Dsp 
       MS1-Dsp CS-Sram We-Sram Oe-Sram OeAdd-Dsp OeData-Dsp DirData-Dsp Timexp Flag1-Dsp  Flag2-Dsp 
       Flag3-Dsp OeAdd-TGIR OeData-TGIR DirData-TGIR Wr-Strobe Clk-By-2 spare1 spare2 OeData-APBuf0 OeData-APBuf1 
       OeData-APBuf2 OeData-APBuf3 OeData-APBuf4 OeData-APBuf5 }

	{"MSL Signals" 	DDS_CR0 DDS_CR1 DDS_CR2 DDS_CR3 DDS_CR4 DS1_CR0 DS1_CR1 DS1_CR2 DS1_CR3 DS1_CR4 
	Data_ADC0 Data_ADC1 Data_ADC2 Data_ADC3 Data_ADC4 Busy_ADC MSL_DtAck AMux_RdOe AMux_DataSeg AMux_OeSeg
	AMux_ClkSeg AMux_DataSp AMux_OeSp AMux_ClkSp Pds_Gate Pds_Reset Clk_Adc Convert anamuxackseg anamuxackspare blr4}

	{"Salti Crystal Signals" DDS0 DDS1 DDS2 DDS3  PDS_Gate PDS_Reset FT_Sample Val_Sample BLR_Out Encod_Command
	ADC_CVT ADC_Busy ADC_Clk ADC_Coding End_ADC_Rdt Timeout_Rst CFD_Inner DtReady Renout AddRam_Run0
	Veto_Flag ADC_Shift&Ce DDS_Sp}

	{"Salti Common Signals #1" CFD_FP Veto_FP FT Val(unused) Inh(unused) Renin Orvalack StartRdt DtReady_Salti
	DtAck LTReset_in Wr_Strobe Resetfifo SS_Data SS_Clk SS_Strobe Link_Clk Link_Oe Link_Ack Link_Data0 
	Link_Data1 Link_Data2 Link_Data3}

	{"Salti Common Signals #2" StopCounter Latch_Seg_Pat Scaler_Cnt_Ce Wr_Scaler_Sram Ld_Scaler_oldVal 
	Incr_Scaler Wr_Scaler Rst_Scaler Start_Rst_Scal Oe_Scaler}

        {"Trigger Signals" Fast_Trigger Inhibit Validation Event-Reject Counter-En}
        {"Internal Readout lines"  Valack Coding-Bus StartReadout Renin DTready DtAck LPass ClkA-Fifo EnA-Fifo Flag0-Dsp Flag1-Dsp Flag2-Dsp Flag3-Dsp Irq0-Dsp Irq1-Dsp}
        {"External Readout lines" Inh-Req AS-VME* DS-VME R/W-VME* ModRoco Card-Renin* BLTACK-Card BLTACK-Bus FDTACK DTACK-Bus* 
       Decode-Sel Oe_Card Lt_Reset ClkB-Fifo EnB-Fifo Empty-Fifo Reset-Fifo Sysclk}
        {"DSP Interface" LINK-CE DMA-Req 
       DMA-Grant Link4-Start Link4-Ack Link4-Clk Link4-Dat0 Link4-Dat1 Link4-Dat2 Link4-Dat3 Dtack-VXI Oe-DSP-Data-Run 
       Evt-Cpt-Ce  Rdt-Evt-Fault Rdt-Evt-Match Wr-DSP Rd-DSP CS-DSP OeAdd-DSP MS1-DSP HBR-DSP HBG-DSP 
       CS-Sram We-Sram Oe-Sram }
}


loadsource gir
loadsource  common.vxi
loadsource  vxicontrol.common

#    enable register needs special attention because 2 bits have to be written
proc enable->param {p v}   {global $p; set $p [expr [scan-int $v] & 1]}
proc param->enable {p v u} {
   if {$v == 0} then {return 0} else {return 3}
}

proc click arg {
   global debug userselection allchans
   if {$debug} then {puts stderr "proc click called with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      *REDISPLAY  {click-redisplay}
      FORMAT      {click-format}
      ENGINEERING  {click-$v}

      GIR*         {click-GIRwindow $w $v}

      MUX-*  {click-inspection $w [lindex $arg 4]}

      CHANNEL	{
		click-channel $v
        catch {send cluster click-channel $v}
        catch {send clusterge click-channel $v}
		}
      SEGMENT   {click-segment $v}


      PARAM {click-param $v}

      default   {
          if {$allchans < 0} then {set userselection 1}
             click-on $w $v
             set userselection 0
      }
   }
}

set electronicsframe "[self frame-name].electronics"
set electronicsvisible 0

set testsaltiframe [self frame-name].testsalti
set testsaltivisible 0


proc make-frame1 {} {
  global env chanlist seglist digitalinspmenu analogueinspmenu voltageinsptable stepmenu stepmode

  :frame "[self frame-name]" :label "[self frame-title]" :show-footer T  :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

    :panel PANEL1 :layout T :padx 10 :pady 5
      :layout H; :row-gap 10; :col-gap 10
      :choice-stack CHANNEL :label "Current Channel:" :strings $chanlist :valuex 18c
      :choice-stack SEGMENT :label "Current Crystal:"  :strings $seglist
      :checkbox ENABLE :label "Enable:" :valuex 10c

    :panel PANEL2 :layout T :padx 10 :pady 10
     :layout V; :row-gap 5
      :slider  FTGATE    :label "FT Gate  :"  		:min 0 :max 255 :valuex 30c
      :slider FTDELAY    :label "FT Delay :" 		:min 0 :max 255   :valuex 30c
      :slider VALGATE    :label "Validation Gate :" 	:min 0 :max 255   :valuex 30c
      :slider VALDELAY   :label "Validation Delay :" 	:min 0 :max 255   :valuex 30c
      :slider INHGATE    :label "Inhibit Gate :" 	:min 0 :max 65635   :valuex 30c
      :checkbox SIMSTARTTR :label "Simulate Start Trigger" 

      :vskip 10
      :layout H; :col-gap 10; :row-gap 10
      :next-row T
      :menubutton MUX-AI1 :label "Analogue Inspection 1:" :w 22 :menu $analogueinspmenu
      :message MUX-AI1-USE   :label ""
      :next-row T
      :menubutton MUX-AI2 :label "Analogue Inspection 2:" :w 22 :menu $analogueinspmenu
      :message MUX-AI2-USE   :label ""
      :next-row T
      :menubutton MUX-DI1 :label "Digital Inspection 1:"  :w 22 :menu $digitalinspmenu
      :message MUX-DI1-USE   :label ""
      :next-row T
      :menubutton MUX-DI2 :label "Digital Inspection 2:"  :w 22 :menu $digitalinspmenu
      :message MUX-DI2-USE   :label ""
      :next-row T
      :menubutton MUX-VI  :label "Voltage Inspection:"    :w 22 :menu $voltageinsptable
      :message MUX-VI-USE   :label ""

    :panel PANEL3 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5
      :message M5 :label "AP BUFFERS REGISTERS TEST" :bold T :valuex 30c
    :next-row T
      :message M8 :label "Read/Write in GIR" :bold T :valuex 22c
      :message M9 :label "Read in TGIR" :bold T :valuex 13c
      :message M10 :label "Read/Write in GIR" :bold T :valuex 20c
      :message M11 :label "Read in TGIR" :bold T :valuex 13c
    :next-row T
      :message M6 :label "AP1" :bold T :valuex 25c
      :message M7 :label "AP3" :bold T :valuex 28c
     :next-row T
     :text    REGAP11W    :label "Buffer 1:" :w 12 
     :text    REGAP11R    :label "" :w 12 :read-only T 
	:hskip 8
     :text    REGAP31W    :label "" :w 12 
     :text    REGAP31R    :label "" :w 12 :read-only T 
    :next-row T
      :text    REGAP12W    :label "Buffer 2:" :w 12 
      :text    REGAP12R    :label "" :w 12 :read-only T 
	:hskip 8
      :text    REGAP32W    :label "" :w 12 
      :text    REGAP32R    :label "" :w 12 :read-only T
    :next-row T
      :text    REGAP13W    :label "Buffer 3:" :w 12 
      :text    REGAP13R    :label "" :w 12 :read-only T 
	:hskip 8
      :text    REGAP33W    :label "" :w 12 
      :text    REGAP33R    :label "" :w 12 :read-only T
    :next-row T
      :message M12 :label "AP2" :bold T :valuex 25c 
     :next-row T
    :text    REGAP22W    :label "Buffer 2:" :w 12 
     :text    REGAP22R    :label "" :w 12 :read-only T  
      :text    REGAP21R    :label "Evt-in:" :w 12 :read-only T

   :panel PANEL6  :layout B :padx 10 :after FOOTER
    :layout H
      :button REDISPLAY 
      :hskip 15
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics testsalti software]
      GIRbutton
      :button HELP          :command click-help
   :show T
}

     

proc make-electronics {} {
  global env electronicsframe electronicsvisible

  :frame "$electronicsframe" :label "TGIRBGA Electronics" :resize F :transient T

   :panel P20 :layout T :padx 5 :pady 5
      :layout H; :row-gap 5
      :message GMCR              :label "GIR Control Register:" :bold T  :valuex 20c 
      :message VXIREGISTER       :label "VXI Registers:"  :bold T        :valuex 30c
    :next-row T
      :checkbox LASTCARD  :label "Last Card:"                            :valuex 20c
      :text MODELCODE     :label "Model Code:" :w 6  :read-only T        :valuex 20c
    :next-row T
      :checkbox RESETFIFO      :label "Reset Fifo:"                      :valuex 20c
      :text SERIALNUM     :label "Serial Number:" :w 6 :read-only T      :valuex 20c
    :next-row T
      :checkbox RESETDSP      :label "Reset DSP:"                        :valuex 20c
      :text MODLEVEL      :label "Modification Level:" :w 6 :read-only T :valuex 20c
    :next-row T
      :checkbox RESETGIR      :label "Reset GIR:"                        :valuex 20c
      :text MANID         :label "Manufacturer ID:" :w 6  :read-only T   :valuex 20c

   :panel P21 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5
      :message M1 :label "TGIR DSP CONTROL" :bold T :valuex 20c
      :message M2 :label "TGIR Readout CONTROL" :bold T :valuex 30c
    :next-row T
      :checkbox TDCRDMAENABLE  :label "Enable Transfert DMA" :valuex 20c
      :checkbox TRCRFP0EN  :label "Enable FP0 Input" :valuex 20c
      :next-row T
      :checkbox TDCRDATAGIR  :label "Enable Data2GIR" :valuex 20c
      :checkbox TRCRFP1EN  :label "Enable FP1 Input" :valuex 20c
      :next-row T
      :checkbox TDCRLINK4  :label "Enable Link4" :valuex 20c
      :checkbox TRCRFP2EN  :label "Enable FP2 Input" :valuex 20c
      :next-row T
      :checkbox TDCRDMATEST  :label "Enable Test DMA" :valuex 20c
      :checkbox TRCRTSTBOARDEN  :label "Enable Test Board" :valuex 20c


   :panel P22 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5
      :message M3 :label "TGIR STATUS" :bold T :valuex 20c
      :message M4 :label "TGIR RESET CONTROL" :bold T :valuex 30c
    :next-row T
      :checkbox TSRINACTGIR  :label "Inhibit from GIR On" :valuex 20c
      :checkbox TRAZDSP  :label "Reset DSP" :valuex 20c
      :next-row T
      :checkbox TSRINACTRM  :label "Inhibit from RM On" :valuex 20c
      :checkbox TRAZLCA  :label "Reset LCA" :valuex 20c
      :next-row T
      :checkbox TRAZBOARD  :label "Reset Board" :valuex 45c

   :panel P23 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5
      :message M3 :label "TGIR RM Register" :bold T :valuex 20c
    :next-row T
      :checkbox RMVALID1  :label "Valid 1" :valuex 20c
      :checkbox RMRAZ  :label "Reset" :valuex 20c
      :next-row T
      :checkbox RMVALID2  :label "Valid 2" :valuex 20c
      :checkbox INHREQRM  :label "Inh Req" :valuex 20c
      :next-row T
      :checkbox RMSYNCHT  :label "Synch Test" :valuex 20c
      :checkbox REJEVT  :label "Reject Evt" :valuex 20c
    :next-row T
      :checkbox RMGOSTOP  :label "GO Stop" :valuex 20c
      :checkbox FINCODE  :label "Fin Code" :valuex 20c
      :next-row T
      :checkbox RMMEMECH  :label "Memech" :valuex 20c
      :checkbox FINLECT  :label "Fin Lect" :valuex 20c


  :show T
 set electronicsvisible 1
}

proc click-testsalti {} {
#  display testsalti sub frame
   global testsaltivisible testsaltiframe
   if {$testsaltivisible==0} then {make-testsalti} else {open-frame $testsaltiframe}
   click-redisplay
}


proc make-testsalti {} {
  global env testsaltiframe testsaltivisible

  :frame "$testsaltiframe" :label "Test Salti" :resize F :transient T

   :panel P30 :layout T :padx 5 :pady 5
      :layout H; :row-gap 5
      :message Tsalti1           :label "MEGA SWITCH LCA REGISTERS:" :bold T :valuex 40c
    :next-row T
      :choice MSLSCR	:label "Select Crystal"	:strings [list A B C D] :value 0 
      :choice DTDSEL	:label "Enable DTD"	:exclusive F	:strings [list 0 1 2 3 Sp] :value 0



    :panel P31 :layout T :padx 10 :pady 10
     :layout V; :row-gap 5
      :slider  DTHTHSEG0    :label "DTD Thresh Seg0 :"  	:min 0 :max 255 :valuex 25c
      :slider  DTHTHSEG1    :label "DTD Thresh Seg1 :"  	:min 0 :max 255 :valuex 25c
      :slider  DTHTHSEG2    :label "DTD Thresh Seg2 :"  	:min 0 :max 255 :valuex 25c
      :slider  DTHTHSEG3    :label "DTD Thresh Seg3 :"  	:min 0 :max 255 :valuex 25c
      :slider  DTHTHSEGS    :label "DTD Thresh Sp :"  		:min 0 :max 255 :valuex 25c
	:vskip 10

      :message Tsalti2   :label "SALTI COMMON REGISTERS:" 	:bold T 	:valuex 40c
      :slider  PDSWTH    :label "PDS Width :"  			:min 0 :max 255 :valuex 25c
      :slider PDSDEL    :label "PDS Gate Delay :" 		:min 0 :max 255 :valuex 25c
      :slider VALSAMWTH    :label "Val Sample Width :" 		:min 0 :max 255 :valuex 25c
      :slider WATDOGSAM   :label "Watchdog Sample :" 		:min 0 :max 255 :valuex 25c


   :panel P32 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5; :col-gap 5
      :message Tsalti3 :label "Common Register Control" :bold T :valuex 30c
    :next-row T
      :choice 	CRCCLOVERMODE	:label "Clover Mode"	:valuex 15c :strings [list channel clover] :value 0 
      :checkbox SALTIRDT  :label "Disable Salti Readout" :valuex 20c
      :next-row T
      :choice 	CRCSTOPMODE	:label "Stop Mode"	:valuex 15c :strings [list FT Or_CFD] :value 0 
      :checkbox LATCHSCALER  	:label "Enable Latch Scaler"	:valuex 22c
      :next-row T
      :choice 	CRCSTARTMODE	:label "Start Mode"	:valuex 15c :strings [list CFD_Inner DTD] :value 0
      :checkbox SCALERS  	:label "Enable Scaler"	:valuex 18c
      :next-row T
      :choice 	SSMODE		:label "SS Mode"	:valuex 15c :strings [list Min Max] :value 0
      :checkbox SS  		:label "Enable SS" 	:valuex 25c
      :next-row T
      :choice 	VETO		:label "Veto Mode"	:valuex 15c :strings [list Mark Reject] :value 0
      :checkbox INHREQ 		:label "Send Inh Req"  	:valuex 22c

      :next-row T
      :vskip 10 
      :message Tsalti4 		:label "Sliding Scale Control" :bold T :valuex 30c
      :next-row T
      :text    SSCOUNTER    	:label "SS Value Counter:" :valuex 18c :w 12
      :checkbox SSPULSE  	:label "Simulate SS Pulse" 	:valuex 18c
      :next-row T

      :message Tsalti5 		:label "CFD Register Control" :bold T :valuex 30c
       :next-row T
      :choice 	CFDDIR		:label "Segments"	:valuex 12c :strings [list 0 1 2 3] :value 0 
      :checkbox CFDEN  	:label "CFD Enable" 
       :next-row T
      :checkbox TSALTIRDT  	:label "Test Salti Rdt En" 
      :checkbox LINKACK  	:label "Link Ack En" 
      :button READSCALER	:command click-readscaler

      :next-row T
      :vskip 10 
      :message Tsalti6   :label "SALTI CHANNEL REGISTERS:" 	:bold T 	:valuex 40c
      :next-row T
      :slider  FTSAMP    :label "FT_Sample Delay :"  		:min 0 :max 255 :valuex 25c
      :next-row T
      :choice CRCRADCRDT	:label "ADC Rdt En Select"	:exclusive F	:strings [list 0 1 2 3] :value 0
      :checkbox CRYSLTEN  	:label "Crystal LT Enable" 	:valuex 19c
      :next-row T
      :choice CRCRTDCRDT	:label "TDC Rdt En Select"	:exclusive F	:strings [list 0 1 2 3] :value 0
      :checkbox CRYSTDCEN  	:label "Crystal TDC Enable" 	:valuex 20c
      :next-row T
      :choice SPSEGSEL		:label "Segment Replaced"	:strings [list 0 1 2 3] :value 0
      :checkbox SPAREEN  	:label "Spare Enable" 	:valuex 26c



  :show T
 set testsaltivisible 1
}

proc click-readscaler {args} {
 global cardtype chanindex

   set CurrentVXIModule $cardtype$chanindex

write-vxi-register $CurrentVXIModule.CRC.LatchScalers 1


   array set nomevent {0 "CrystalA Segment0" 1 "CrystalA Segment1" 2  "CrystalA Segment2" 3 "CrystalA Segment3" \
4 "CrystalB Segment0" 5 "CrystalB Segment1" 6 "CrystalB Segment2" 7 "CrystalB Segment3" \
8 "CrystalC Segment0" 9 "CrystalC Segment1" 10  "CrystalC Segment2" 11 "CrystalC Segment3" \
12 "CrystalD Segment0" 13 "CrystalD Segment1" 14  "CrystalD Segment2" 15 "CrystalD Segment3" }

set i 0
	set length 16
	set scalerreg $CurrentVXIModule.Scaler.Mem
	modify-vxi-register $scalerreg "-o0x840 -l $length"	
      	set DataRAM [read-vxi-register $scalerreg]
       foreach word $DataRAM {
	insert-log "[format "%24s   :   0x%x" $nomevent($i) $word]"
	incr i}

write-vxi-register $CurrentVXIModule.CRC.LatchScalers 0

}
