
#     modify 1/6/99 by L.OLIVIER (GIP/GANIL)

#   u2m.defn.tcl     Ganil U2M  VXI card

#    load address definitions

loadsource GroupDefn

proc {AddU2MModule}  {module slot}  {
   global registerbase namebase cardtype 

   set registerbase $cardtype$module
   set namebase $cardtype$module

   delete-vxi-registers $registerbase.*

   U2MVXIRegisters $slot
   U2MModuleRegisters  $slot
}

proc u2m_register {registername class attributes} {
   global registerbase
   define-vxi-register $registerbase $class $registername "$attributes"
}

proc U2MVXIRegisters {slot} {
   u2m_register     VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   u2m_register     VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   u2m_register     VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   u2m_register     VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   u2m_register     VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   u2m_register     VXI.Status     xSht   "-s$slot -o4  -pro -w16 -fx"
   u2m_register     VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   u2m_register     VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   u2m_register     VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   u2m_register     VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   u2m_register     VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   u2m_register     VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   u2m_register     VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   u2m_register     VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
   u2m_register     LastCard       xSht   "-s$slot -o4  -prw -w16 -fd -b4 -l1"
}

proc U2MModuleRegisters {slot} {
   u2m_register  VXLOGADD   xSht   "-s$slot -o0 -pwo -w16"
   u2m_register  VXCONTRL   xSht   "-s$slot -o4 -pwo -w16"
   u2m_register  VXCONTRL.MP   xSht   "-s$slot -o4 -prw -w16 -fd -b9 -l1"
   u2m_register  VXCONTRL.ZP   xSht   "-s$slot -o4 -prw -w16 -fd -b8 -l1"

   u2m_register  VXSYNCTST  xSht  "-s$slot -o0x30 -w16 -prw -b0 -l0 -i0x8001"
   u2m_register  VXINIT     xSht  "-s$slot -o0x24 -w16 -prw -b0 -l0 -i0x8003"
   u2m_register  VXWORK     xSht  "-s$slot -o0x26 -w16 -prw -b0 -l0 -i0x8004"
   u2m_register  VXCT       xSht  "-s$slot -o0x2a -w16 -prw -b0 -l0 -i0x8006"
   u2m_register  VXMRST     xSht  "-s$slot -o0x28 -w16 -prw -b0 -l0 -i0x8005"
   u2m_register  VXCODING   xSht  "-s$slot -o0x20 -w16 -prw -b0 -l0 -i0x8000"
   u2m_register  VXREADOUT  xSht  "-s$slot -o0x22 -w16 -prw -b0 -l0 -i0x8001"
   u2m_register  VXDEL      xSht  "-s$slot -o0x2c -w16 -prw -b0 -l0 -i0x8002"

   u2m_register  U2M.STATUS    xDig  "-s$slot -c0 -o0x000e -pro -w16 -fx"
   u2m_register  U2M.CONFIG    xDig  "-s$slot -c0 -o0x0000 -w16 -prw -fx -b0 -l0 -i0x0"
  u2m_register  U2M.CMD    xDig  "-s$slot -c0 -o0x000c -w16 -pwo -fx -b0 -l0 -i0x0"

   u2m_register  U2M.GRMEM    xDig  "-s$slot -c0 -o0x0004 -w16 -prw -fx -b0 -l0 -i0x0"
   u2m_register  U2M.GROUP    xDig  "-s$slot -c0 -o0x0006 -w16 -prw -fx -b0 -l0 -i0x0"
   u2m_register  U2M.EG1    xDig  "-s$slot -c0 -o0x0008 -w16 -prw -fx -b0 -l0 -i0x0"
   u2m_register  U2M.EG2    xDig  "-s$slot -c0 -o0x000a -w16 -prw -fx -b0 -l0 -i0x0"
   u2m_register  U2M.VISU    xDig  "-s$slot -c0 -o0x0010 -w16 -prw -fx -b0 -l0 -i0x0"
   u2m_register  U2M.INSP    xDig  "-s$slot -c0 -o0x0012 -w16 -prw -fx -b0 -l0 -i0x0"
}


#    for setup of the module it is possible to use the procedures

#       wrl  slot_relative_address  [value] [option]
#       wrw  slot_relative_address  [value] [option]

#     value  -  if omitted default value is 0
#     option -  if = 1  read back of location is inhibited  (default = 0  location is read after write)

proc {U2M_DAQ-setup}  {args}  {
#    Ganil U2M module
  set module [first $args]
}



proc {U2M_DAQ-reset}  {args}  {
#    Ganil U2M module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 1
}


proc {U2M_DAQ-go}  {args}  {
#    Ganil U2M module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 0
  write-vxi-register $module.VXCONTRL.ZP 1
}

proc {U2M_DAQ-halt}  {args}  {
#    Ganil U2M module
  set module [first $args]
  write-vxi-register $module.VXCONTRL.MP 1
}
